unit MoviesU;

interface

uses
  GIFImage, jpeg,Math, clipbrd,inifiles, shellapi,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, FileCtrl, RzFilSys, Menus,  CheckLst,
  ComCtrls, ImgList, ToolWin,GradText,
  Buttons, janDriveComboBox, janTabBar, janFX, dfsSplitter;

type
// add pro wizard styles after wssmoothrotate in TWizardStyle
// preferably at the end.
// this reserves them for the pro version only

  TWizardStyle=(
    wsTransition,wsRotateLeftRight,
    wsRotateTopDown,wsBlindsDown,
    wsBlindsRight,wsWipeRight,
    wsWipeleft,wsWipeDown,
    wsWipeUp,wsCurtainOH,
    wsCurtainCH,wsCurtainOV,
    wsCurtainCV,wsBoxIn,
    wsBoxOut,wsDiagonalDR,
    wsDiagonalDL,wsDiagonalUR,
    wsDiagonalUL,wsCrossIn,
    wsCrossOut,wsCircleOut,
    wsSweepLeft,wsSweepRight,
    wsSweepLR,
    wsMarqueeUp,wsMarqueeDown,wsMarqueeUpDown,
    wsMarqueeLeft,wsMarqueeRight,wsMarqueeLeftRight,
    wsPlasmaSmall,wsPlasmaLarge,wsPlasmaXLarge,
    wsPlasmaTurbo,
    wsSmoothRotate,
    wsFishEye,
    wsSplitBlur,wsGaussianBlur,wsTwist,
    wsSqueezeTop,wsSqueezeBottom,wsSqueezeDiamond,wsSqueezeWaste,
    wsSqueezeRound,wsSqueezeRound2,wsMozaic,
    wsColorNoise,wsMonoNoise,wsBrightness,
    wsSplitLight,wsSplitLightReverse,
    wsContrast,wsSaturation,wsTile,
    wsGrowCenter,wsGrowTop,wsGrowBottom,
    wsShrinkCenter,wsShrinkTop,wsShrinkBottom,
    wsSegmentTop,wsSegmentLeft,wsSegmentRight,wsSegmentBottom,
    wsWings,wsFadeIn,wsFadeOut,wsFadeInOut,
    wsSpot,wsSpotLarge,wsSpotFade,wsSpotLargeFade,
    wsCheckerHor, wsFoldRight,wsMaskMandelBrot,
    wsFilterBlue,wsFilterGreen,wsFilterRed,
    wsKeepBlue,wsKeepGreen,wsKeepRed,
    wsShake,wsShakeDown,
    wsTriangles,wsTexTile,wsTexoverlap,
    wsTextType,wsTextGrow,wsTextmarquee,wsTextLines,
    wstextAccent,wsButtonize,wsdancespot,
    wsactorRight,wsactorleft,wsactordown,wsactorup,
    wsactorpath,wsactorcircleLeft, wsactorcircleright,
    wsactorswing,wsactorquatro,
    wsactorspiralLeft,wsactorspiralRight);

  TMoviesF = class(TForm)
    ScrollBoxSource: TScrollBox;
    Panel1: TPanel;
    Panel2: TPanel;
    ImageAnimate: TImage;
    SaveDialog: TSaveDialog;
    filespop: TPopupMenu;
    Add1: TMenuItem;
    Listpop: TPopupMenu;
    Delete1: TMenuItem;
    MainMenu1: TMainMenu;
    SaveAs1: TMenuItem;
    Animation1: TMenuItem;
    Create1: TMenuItem;
    Image1: TMenuItem;
    Scroll1: TMenuItem;
    Up1: TMenuItem;
    Down1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Duplicate1: TMenuItem;
    Invert1: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    FramePointer: TLabel;
    N3: TMenuItem;
    Stop1: TMenuItem;
    FontDialog1: TFontDialog;
    framepop: TPopupMenu;
    N4: TMenuItem;
    SaveAs2: TMenuItem;
    SaveDialog1: TSaveDialog;
    N6: TMenuItem;
    Delay1: TMenuItem;
    SetFrames1: TMenuItem;
    Options1: TMenuItem;
    FrameDelay1: TMenuItem;
    DefTrans: TMenuItem;
    Open2: TMenuItem;
    OpenDialog1: TOpenDialog;
    Tools1: TMenuItem;
    GIFExplorer1: TMenuItem;
    Effect1: TMenuItem;
    Backgrounds1: TMenuItem;
    DelayAll1: TMenuItem;
    ColorDialog1: TColorDialog;
    mnuFrame: TMenuItem;
    New1: TMenuItem;
    AVItoGIFconverter1: TMenuItem;
    GIFtoAVIconverter1: TMenuItem;
    Panel5: TPanel;
    CheckBoxMerge: TCheckBox;
    CheckBoxCrop: TCheckBox;
    N5: TMenuItem;
    Optimize1: TMenuItem;
    anisize: TLabel;
    New2: TMenuItem;
    Edit1: TMenuItem;
    Delete2: TMenuItem;
    Transparent1: TMenuItem;
    CreateSelection1: TMenuItem;
    N9: TMenuItem;
    Arrange1: TMenuItem;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    btnnew: TToolButton;
    ToolButton2: TToolButton;
    btnanimate: TToolButton;
    btnanimateselection: TToolButton;
    ToolButton4: TToolButton;
    btnedit: TToolButton;
    btnnewframe: TToolButton;
    btndeleteframe: TToolButton;
    btnopen: TToolButton;
    ToolButton7: TToolButton;
    btnstop: TToolButton;
    btnsaveani: TSpeedButton;
    btnduplicate: TToolButton;
    btndelay: TToolButton;
    wizlist: TImageList;
    btnwizard: TToolButton;
    btnwizinsert: TToolButton;
    wizpop: TPopupMenu;
    Transition1: TMenuItem;
    RotateLeftRight1: TMenuItem;
    RotateTopDown1: TMenuItem;
    BlindsDown1: TMenuItem;
    BlindsRight2: TMenuItem;
    Wipe1: TMenuItem;
    Right4: TMenuItem;
    Left3: TMenuItem;
    Up3: TMenuItem;
    Down4: TMenuItem;
    Curtain2: TMenuItem;
    OpenHoriz1: TMenuItem;
    CloseHoriz1: TMenuItem;
    OpenVert1: TMenuItem;
    CloseVert1: TMenuItem;
    Box2: TMenuItem;
    In2: TMenuItem;
    Out2: TMenuItem;
    Diagonal2: TMenuItem;
    DownRight3: TMenuItem;
    DownLeft3: TMenuItem;
    UpRight2: TMenuItem;
    UpLeft3: TMenuItem;
    Cross2: TMenuItem;
    In3: TMenuItem;
    Out3: TMenuItem;
    Circle2: TMenuItem;
    CircleOut2: TMenuItem;
    Sweep2: TMenuItem;
    Left4: TMenuItem;
    Right5: TMenuItem;
    LeftRight1: TMenuItem;
    Effects1: TMenuItem;
    SmoothRotate1: TMenuItem;
    FishEye1: TMenuItem;
    SplitBlur1: TMenuItem;
    Twist1: TMenuItem;
    Squeeze1: TMenuItem;
    Top1: TMenuItem;
    Bottom1: TMenuItem;
    Diamond1: TMenuItem;
    Waste1: TMenuItem;
    Noise1: TMenuItem;
    Color1: TMenuItem;
    Mono1: TMenuItem;
    Blur1: TMenuItem;
    Gaussian1: TMenuItem;
    Light1: TMenuItem;
    Brightness1: TMenuItem;
    Round1: TMenuItem;
    RoundDouble1: TMenuItem;
    Mozaic1: TMenuItem;
    Tile1: TMenuItem;
    Grow1: TMenuItem;
    Shrink1: TMenuItem;
    Grow2: TMenuItem;
    Shrink2: TMenuItem;
    Top2: TMenuItem;
    Top3: TMenuItem;
    Bottom2: TMenuItem;
    Bottom3: TMenuItem;
    Segment1: TMenuItem;
    Top4: TMenuItem;
    Left2: TMenuItem;
    Right3: TMenuItem;
    Bottom4: TMenuItem;
    Wings1: TMenuItem;
    Contrast1: TMenuItem;
    Saturation1: TMenuItem;
    Darkness1: TMenuItem;
    FadeOut1: TMenuItem;
    FadeInOut1: TMenuItem;
    SpotLeftRight1: TMenuItem;
    SpotLarge1: TMenuItem;
    SpotFade1: TMenuItem;
    SpotLargeFade1: TMenuItem;
    SplitLight1: TMenuItem;
    SplitLightReverse1: TMenuItem;
    N2: TMenuItem;
    RotationAngle2: TMenuItem;
    ToolButton10: TToolButton;
    frameeffectpop: TPopupMenu;
    FlipLeftRight1: TMenuItem;
    FlipUpDown1: TMenuItem;
    Rotate1: TMenuItem;
    Trace2: TMenuItem;
    Shadow2: TMenuItem;
    UpLeft2: TMenuItem;
    UpRight1: TMenuItem;
    DownLeft2: TMenuItem;
    DownRight2: TMenuItem;
    Blinds1: TMenuItem;
    CheckerBoard1: TMenuItem;
    Right2: TMenuItem;
    Marquee1: TMenuItem;
    Up2: TMenuItem;
    Down2: TMenuItem;
    UpDown1: TMenuItem;
    Left5: TMenuItem;
    Right6: TMenuItem;
    LeftRight2: TMenuItem;
    Overlay1: TMenuItem;
    N50Opaque1: TMenuItem;
    N25Opaque1: TMenuItem;
    Fold1: TMenuItem;
    Right7: TMenuItem;
    MaskMandelBrot1: TMenuItem;
    FilterBlue1: TMenuItem;
    Color2: TMenuItem;
    FilterGreen1: TMenuItem;
    FilterRed1: TMenuItem;
    KeepBlue1: TMenuItem;
    KeepGreen1: TMenuItem;
    KeepRed1: TMenuItem;
    MultiShake1: TMenuItem;
    Shake1: TMenuItem;
    UpDown2: TMenuItem;
    Register1: TMenuItem;
    PurchaseOnLine1: TMenuItem;
    WebSite1: TMenuItem;
    N7: TMenuItem;
    ProPlasma1: TMenuItem;
    ProPlasma2: TMenuItem;
    Large1: TMenuItem;
    ExtraLarge1: TMenuItem;
    LargeTurbo1: TMenuItem;
    Blur2: TMenuItem;
    FlipLeftRight2: TMenuItem;
    FlipTopDown1: TMenuItem;
    Mirror1: TMenuItem;
    Right8: TMenuItem;
    Down3: TMenuItem;
    Triangles1: TMenuItem;
    Texturize1: TMenuItem;
    Tile2: TMenuItem;
    TileOverlap1: TMenuItem;
    janTabBar1: TjanTabBar;
    janTabSection1: TjanTabSection;
    janTabSection2: TjanTabSection;
    List: TListBox;
    janDriveComboBox1: TjanDriveComboBox;
    dirbox: TRzDirectoryListBox;
    Files: TRzFileListBox;
    TextWizardFont1: TMenuItem;
    ProText1: TMenuItem;
    Type1: TMenuItem;
    TextWizardText1: TMenuItem;
    TextWizardColor1: TMenuItem;
    Grow3: TMenuItem;
    N8: TMenuItem;
    MarkTextPosition1: TMenuItem;
    Marquee2: TMenuItem;
    Lines1: TMenuItem;
    Accent1: TMenuItem;
    TextWizard1: TMenuItem;
    AccentColor1: TMenuItem;
    Buttonize1: TMenuItem;
    DancingSpot1: TMenuItem;
    dfsSplitter1: TdfsSplitter;
    dfsSplitter2: TdfsSplitter;
    ProActor1: TMenuItem;
    Right9: TMenuItem;
    Left6: TMenuItem;
    Down5: TMenuItem;
    Up4: TMenuItem;
    Path1: TMenuItem;
    Circle1: TMenuItem;
    CircleRight1: TMenuItem;
    Swing1: TMenuItem;
    Quatro1: TMenuItem;
    Spiral1: TMenuItem;
    SpiralRight1: TMenuItem;
    SetLoops1: TMenuItem;
    procedure CreateAnimation(All:boolean);
    procedure ButtonSaveClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ImageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure ListDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ListDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListClick(Sender: TObject);
    procedure Up1Click(Sender: TObject);
    procedure Down1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure Duplicate1Click(Sender: TObject);
    procedure Invert1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure IFrameMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure IFrameDblClick(Sender: TObject);
    procedure goNewClick(Sender: TObject);
    procedure Caption1Click(Sender: TObject);
    procedure SaveAs2Click(Sender: TObject);
    procedure Trace(Sender: TObject);
    procedure Rotate(Sender: TObject);
    procedure RotationAngle1Click(Sender: TObject);
    procedure Delay1Click(Sender: TObject);
    procedure SetFrames1Click(Sender: TObject);
    procedure FrameDelay1Click(Sender: TObject);
    procedure DefTransClick(Sender: TObject);
    procedure Open2Click(Sender: TObject);
    procedure GIFExplorer1Click(Sender: TObject);
    procedure Effect1Click(Sender: TObject);
    procedure Append;
    procedure Backgrounds1Click(Sender: TObject);
    procedure DelayAll1Click(Sender: TObject);
    procedure GradText1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GradText1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GradText1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AVItoGIFconverter1Click(Sender: TObject);
    procedure GIFtoAVIconverter1Click(Sender: TObject);
    procedure Optimize1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure New2Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Delete2Click(Sender: TObject);
    procedure framepopPopup(Sender: TObject);
    procedure Transparent1Click(Sender: TObject);
    procedure Create1Click(Sender: TObject);
    procedure CreateSelection1Click(Sender: TObject);
    procedure Arrange1Click(Sender: TObject);
    procedure btnnewClick(Sender: TObject);
    procedure btnanimateClick(Sender: TObject);
    procedure btnanimateselectionClick(Sender: TObject);
    procedure btneditClick(Sender: TObject);
    procedure btnnewframeClick(Sender: TObject);
    procedure btndeleteframeClick(Sender: TObject);
    procedure btnopenClick(Sender: TObject);
    procedure btnsaveaniClick(Sender: TObject);
    procedure btnstopClick(Sender: TObject);
    procedure btnduplicateClick(Sender: TObject);
    procedure btndelayClick(Sender: TObject);
    procedure btnwizinsertClick(Sender: TObject);
    procedure Transition1Click(Sender: TObject);
    procedure RotateLeftRight1Click(Sender: TObject);
    procedure RotateTopDown1Click(Sender: TObject);
    procedure BlindsDown1Click(Sender: TObject);
    procedure BlindsRight2Click(Sender: TObject);
    procedure Right4Click(Sender: TObject);
    procedure Left3Click(Sender: TObject);
    procedure Up3Click(Sender: TObject);
    procedure Down4Click(Sender: TObject);
    procedure OpenHoriz1Click(Sender: TObject);
    procedure CloseHoriz1Click(Sender: TObject);
    procedure OpenVert1Click(Sender: TObject);
    procedure CloseVert1Click(Sender: TObject);
    procedure In2Click(Sender: TObject);
    procedure Out2Click(Sender: TObject);
    procedure DownRight3Click(Sender: TObject);
    procedure DownLeft3Click(Sender: TObject);
    procedure UpRight2Click(Sender: TObject);
    procedure UpLeft3Click(Sender: TObject);
    procedure In3Click(Sender: TObject);
    procedure Out3Click(Sender: TObject);
    procedure CircleOut2Click(Sender: TObject);
    procedure Left4Click(Sender: TObject);
    procedure Right5Click(Sender: TObject);
    procedure LeftRight1Click(Sender: TObject);
    procedure SmoothRotate1Click(Sender: TObject);
    procedure FishEye1Click(Sender: TObject);
    procedure SplitBlur1Click(Sender: TObject);
    procedure Twist1Click(Sender: TObject);
    procedure Top1Click(Sender: TObject);
    procedure Bottom1Click(Sender: TObject);
    procedure Diamond1Click(Sender: TObject);
    procedure Waste1Click(Sender: TObject);
    procedure Color1Click(Sender: TObject);
    procedure Mono1Click(Sender: TObject);
    procedure Gaussian1Click(Sender: TObject);
    procedure Brightness1Click(Sender: TObject);
    procedure Round1Click(Sender: TObject);
    procedure RoundDouble1Click(Sender: TObject);
    procedure Mozaic1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Grow1Click(Sender: TObject);
    procedure Shrink1Click(Sender: TObject);
    procedure Top2Click(Sender: TObject);
    procedure Top3Click(Sender: TObject);
    procedure ToolBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ScrollBoxSourceMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure Bottom2Click(Sender: TObject);
    procedure Bottom3Click(Sender: TObject);
    procedure Top4Click(Sender: TObject);
    procedure Left2Click(Sender: TObject);
    procedure Right3Click(Sender: TObject);
    procedure Bottom4Click(Sender: TObject);
    procedure Wings1Click(Sender: TObject);
    procedure Contrast1Click(Sender: TObject);
    procedure Saturation1Click(Sender: TObject);
    procedure Darkness1Click(Sender: TObject);
    procedure FadeOut1Click(Sender: TObject);
    procedure FadeInOut1Click(Sender: TObject);
    procedure SpotLeftRight1Click(Sender: TObject);
    procedure SpotLarge1Click(Sender: TObject);
    procedure SpotFade1Click(Sender: TObject);
    procedure SpotLargeFade1Click(Sender: TObject);
    procedure SplitLight1Click(Sender: TObject);
    procedure SplitLightReverse1Click(Sender: TObject);
    procedure FlipLeftRight1Click(Sender: TObject);
    procedure FlipUpDown1Click(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure UpLeft2Click(Sender: TObject);
    procedure UpRight1Click(Sender: TObject);
    procedure DownLeft2Click(Sender: TObject);
    procedure DownRight2Click(Sender: TObject);
    procedure Right2Click(Sender: TObject);
    procedure Up2Click(Sender: TObject);
    procedure Down2Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject);
    procedure Left5Click(Sender: TObject);
    procedure Right6Click(Sender: TObject);
    procedure LeftRight2Click(Sender: TObject);
    procedure N50Opaque1Click(Sender: TObject);
    procedure N25Opaque1Click(Sender: TObject);
    procedure ListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListDblClick(Sender: TObject);
    procedure Right7Click(Sender: TObject);
    procedure MaskMandelBrot1Click(Sender: TObject);
    procedure FilterBlue1Click(Sender: TObject);
    procedure FilterGreen1Click(Sender: TObject);
    procedure FilterRed1Click(Sender: TObject);
    procedure KeepBlue1Click(Sender: TObject);
    procedure KeepGreen1Click(Sender: TObject);
    procedure KeepRed1Click(Sender: TObject);
    procedure MultiShake1Click(Sender: TObject);
    procedure UpDown2Click(Sender: TObject);
    procedure WebSite1Click(Sender: TObject);
    procedure ProPlasma1Click(Sender: TObject);
    procedure Large1Click(Sender: TObject);
    procedure ExtraLarge1Click(Sender: TObject);
    procedure LargeTurbo1Click(Sender: TObject);
    procedure Blur2Click(Sender: TObject);
    procedure FlipLeftRight2Click(Sender: TObject);
    procedure FlipTopDown1Click(Sender: TObject);
    procedure Right8Click(Sender: TObject);
    procedure Down3Click(Sender: TObject);
    procedure Triangles1Click(Sender: TObject);
    procedure Tile2Click(Sender: TObject);
    procedure TileOverlap1Click(Sender: TObject);
    procedure TextWizardFont1Click(Sender: TObject);
    procedure Type1Click(Sender: TObject);
    procedure TextWizardText1Click(Sender: TObject);
    procedure TextWizardColor1Click(Sender: TObject);
    procedure Grow3Click(Sender: TObject);
    procedure MarkTextPosition1Click(Sender: TObject);
    procedure Marquee2Click(Sender: TObject);
    procedure Lines1Click(Sender: TObject);
    procedure Accent1Click(Sender: TObject);
    procedure AccentColor1Click(Sender: TObject);
    procedure Buttonize1Click(Sender: TObject);
    procedure DancingSpot1Click(Sender: TObject);
    procedure Right9Click(Sender: TObject);
    procedure Left6Click(Sender: TObject);
    procedure Down5Click(Sender: TObject);
    procedure Up4Click(Sender: TObject);
    procedure Path1Click(Sender: TObject);
    procedure Circle1Click(Sender: TObject);
    procedure CircleRight1Click(Sender: TObject);
    procedure Swing1Click(Sender: TObject);
    procedure Quatro1Click(Sender: TObject);
    procedure Spiral1Click(Sender: TObject);
    procedure SpiralRight1Click(Sender: TObject);
    procedure SetLoops1Click(Sender: TObject);
  private
    procedure arrange;
    procedure Duplicate;
    function GetImage(i: integer): Timage;
    procedure GetFrame(i:integer);
    procedure SetFrame(i: integer);
    procedure ClearFrame;
    function GetDelay(i: integer): integer;
    procedure InsertImage;
    procedure clear;
    procedure AddFrame(var GIF: Tgifimage; index: integer);
    procedure loadsettings;
    procedure savesettings;
    procedure DeleteAll;
    procedure selectnone;
    procedure AnimateWizList;
    procedure insertwizlist;
    procedure initwizlist;
    procedure DoWizard(Astyle: Twizardstyle);
    function importRect(R: Trect; w, h: integer): Trect;
    procedure setProLite;
    procedure WizLite(Astyle: Twizardstyle);
    procedure TextAccent(frm, bm: TBitmap; i, transframes: integer);



    { Private declarations }
  public
    { Public declarations }

  end;

var
  MoviesF: TMoviesF;
  JanSoft:boolean;
  appldir:string;
  FrameWidth,FrameHeight:integer;
  DefaultWidth,DefaultHeight:integer;
  Frame:Tbitmap;
  FrameX,FrameY:integer;
  FrameNr:integer;
  FrameDraw:boolean;
  FrameDelay:integer;
  Loops:integer;
  DrawShape:string;
  FOrigin,FPrevious:Tpoint;
  TexX,TexY:integer;
  RotAngle:integer;
  thefile:string;
  GadLabelX:integer;
  GadLabelY:integer;
  TransFrames:integer;
implementation

{$R *.DFM}

uses
    GIFExplorerU,PainterEffectsU,PainterQBU, DrawU,
    gif2aviU,avi2gifU, PainterReduceU,  TemplatesU;

const
  cr = chr(13)+chr(10);
  tab = chr(9);
  MaxPixelCount = 32768;

type
TRGBTripleArray = ARRAY[0..MaxPixelCount-1] OF
TRGBTriple;
pRGBTripleArray = ^TRGBTripleArray;
ETweenError = CLASS(Exception);



var
   wizfont:TFont;
   wiztext:TStringlist;
   wizAccent:TColor;
   popcurpos,wizpos:TPoint;

Procedure CreateTweenBitmap(CONST BitmapA:  TBitmap;
                           CONST WeightA:  CARDINAL;
                           CONST BitmapB:  TBitmap;
                           CONST WeightB:  CARDINAL);
  CONST
    MaxPixelCount = 65536;

  TYPE
    TRGBArray = ARRAY[0..MaxPixelCount-1] OF TRGBTriple;
    pRGBArray = ^TRGBArray;

  VAR
    i         :  INTEGER;
    j         :  INTEGER;
    RowA      :  pRGBArray;
    RowB      :  pRGBArray;
    RowTween  :  pRGBArray;
    SumWeights:  CARDINAL;

  FUNCTION WeightPixels (CONST pixelA, pixelB:  CARDINAL):  BYTE;
  BEGIN
    RESULT := BYTE((WeightA*pixelA + WeightB*pixelB) DIV SumWeights)

  END {WeightPixels};

BEGIN
  IF   (BitmapA.PixelFormat <> pf24bit) OR
       (BitmapB.PixelFormat <> pf24bit)
  THEN RAISE ETweenError.Create('Tween:  PixelFormats must be pf24fit');

  IF   (BitmapA.Width  <> BitmapB.Width) OR
       (BitmapA.Height <> BitmapB.Height)
  THEN RAISE ETweenError.Create('Tween:  Bitmap dimensions are not the same');

  SumWeights := WeightA + WeightB;

  frame.Width  := BitmapA.Width;
  frame.Height := BitmapA.Height;
  frame.PixelFormat := pf24bit;

  // If SumWeights is 0, just return a "empty" white image
  IF   SumWeights > 0
  THEN BEGIN

    FOR j := 0 TO frame.Height-1 DO
    BEGIN
      RowA     := BitmapA.Scanline[j];
      RowB     := BitmapB.Scanline[j];
      RowTween := frame.Scanline[j];

      FOR i := 0 TO frame.Width-1 DO
      BEGIN
        WITH RowTween[i] DO
        BEGIN
          rgbtRed   := WeightPixels(rowA[i].rgbtRed,   rowB[i].rgbtRed);
          rgbtGreen := WeightPixels(rowA[i].rgbtGreen, rowB[i].rgbtGreen);
          rgbtBlue  := WeightPixels(rowA[i].rgbtBlue,  rowB[i].rgbtBlue)
        END
      END
    END

  END

END {CreateTweenBitmap};

procedure TransBlinds(
         const BitMapA:tbitmap;
         const BitMapB:tbitmap;
         factor, max:integer);
var
   PS,PR:Pbytearray;
   x,y,w,h:integer;
   isA:boolean;
begin
  frame.pixelformat:=pf24bit;
  w:=BitmapA.width;
  h:=bitmapA.height;
  frame.Width  := w;
  frame.Height := h;
  for y:=0 to h-1 do begin
    PR:=frame.ScanLine [y];
    isA:= (y mod max)> factor;
    if isA then
      PS:=BitmapA.scanline[y]
      else
      PS:=BitmapB.scanline[y];
    for x:=0 to w-1 do begin
      PR[x*3]:=PS[x*3];
      PR[x*3+1]:=PS[x*3+1];
      PR[x*3+2]:=PS[x*3+2];
      end;
    end;
end;

procedure TransBlindsHor(
         const BitMapA:tbitmap;
         const BitMapB:tbitmap;
         factor, max:integer);
var
   PA,PB,PR:Pbytearray;
   x,y,w,h:integer;
begin
  frame.pixelformat:=pf24bit;
  w:=BitmapA.width;
  h:=bitmapA.height;
  frame.Width  := w;
  frame.Height := h;
  for y:=0 to h-1 do begin
    PR:=frame.ScanLine [y];
    PA:=BitmapA.ScanLine [y];
    PB:=bitmapB.scanline[y];
    for x:=0 to w-1 do
      if ((x mod max)>factor) then begin
        PR[x*3]:=PA[x*3];
        PR[x*3+1]:=PA[x*3+1];
        PR[x*3+2]:=PA[x*3+2];
        end
        else begin
        PR[x*3]:=PB[x*3];
        PR[x*3+1]:=PB[x*3+1];
        PR[x*3+2]:=PB[x*3+2];
        end;
    end;
end;

procedure TransMarQueeUp(BitMapA,BitMapB:Tbitmap;
   factor,max:integer);
var RsA,RsB,RdA,RdB:Trect;
    w,h,m:integer;
begin
  w:=BitmapA.width;
  h:=bitmapA.height;
  m:=round(factor/max*h);
  RsB:=rect(0,0,w,m);
  RdB:=rect(0,h-m,w,h);
  RsA:=rect(0,m,w,h);
  RdA:=rect(0,0,w,h-m);
  frame.canvas.CopyRect(RdA,BitmapA.canvas,RsA);
  frame.canvas.copyrect(RdB,BitmapB.canvas,RsB);
end;

procedure TransMarQueeDown(BitMapA,BitMapB:Tbitmap;
   factor,max:integer);
var RsA,RsB,RdA,RdB:Trect;
    w,h,m:integer;
begin
  w:=BitmapA.width;
  h:=bitmapA.height;
  m:=round(factor/max*h);
  RdA:=rect(0,0,w,m);
  RsA:=rect(0,h-m,w,h);
  RdB:=rect(0,m,w,h);
  RsB:=rect(0,0,w,h-m);
  frame.canvas.CopyRect(RdA,BitmapA.canvas,RsA);
  frame.canvas.copyrect(RdB,BitmapB.canvas,RsB);
end;

procedure TransMarQueeLeft(BitMapA,BitMapB:Tbitmap;
   factor,max:integer);
var RsA,RsB,RdA,RdB:Trect;
    w,h,m:integer;
begin
  w:=BitmapA.width;
  h:=bitmapA.height;
  m:=round(factor/max*w);
  RsB:=rect(0,0,m,h);
  RdB:=rect(w-m,0,w,h);
  RsA:=rect(m,0,w,h);
  RdA:=rect(0,0,w-m,h);
  frame.canvas.CopyRect(RdA,BitmapA.canvas,RsA);
  frame.canvas.copyrect(RdB,BitmapB.canvas,RsB);
end;

procedure TransMarQueeRight(BitMapA,BitMapB:Tbitmap;
   factor,max:integer);
var RsA,RsB,RdA,RdB:Trect;
    w,h,m:integer;
begin
  w:=BitmapA.width;
  h:=bitmapA.height;
  m:=round(factor/max*w);
  RdA:=rect(0,0,m,h);
  RsA:=rect(w-m,0,w,h);
  RdB:=rect(m,0,w,h);
  RsB:=rect(0,0,w-m,h);
  frame.canvas.CopyRect(RdA,BitmapA.canvas,RsA);
  frame.canvas.copyrect(RdB,BitmapB.canvas,RsB);
end;

procedure TransCheckerHor(
         const BitMapA:tbitmap;
         const BitMapB:tbitmap;
         factor, max:integer);
var
   PA,PB,PR:Pbytearray;
   x,y,w,h:integer;
   YCheck,XCheck,HCheck:boolean;
begin
  frame.pixelformat:=pf24bit;
  w:=BitmapA.width;
  h:=bitmapA.height;
  frame.Width  := w;
  frame.Height := h;
  frame.canvas.draw(0,0,BitMapA);
  HCheck:=factor>(max div 2);
  YCheck:=false;
  for y:=0 to h-1 do begin
    if (y mod max)=0 then YCheck:= not YCheck;
    PR:=frame.ScanLine [y];
    PA:=BitmapA.ScanLine [y];
    PB:=bitmapB.scanline[y];
    XCheck:=YCheck;
    for x:=0 to w-1 do begin
      if (x mod max)= 0 then XCheck:= not XCheck;
      if XCheck then
      if ((x mod max)<(factor*2)) then begin
        PR[x*3]:=PB[x*3];
        PR[x*3+1]:=PB[x*3+1];
        PR[x*3+2]:=PB[x*3+2];
        end;
      if ((not XCheck)and HCheck) then
      if ((x mod max)<((factor-(max div 2))*2)) then begin
        PR[x*3]:=PB[x*3];
        PR[x*3+1]:=PB[x*3+1];
        PR[x*3+2]:=PB[x*3+2];
        end;
      end;
    end;
end;


Procedure TransCircOut(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,dx,dy,w2,h2:integer;
    x1,y1,x2,y2:integer;
    Acolor:Tcolor;
    bm,bm2:tbitmap;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  w:=frame.width;
  h:=frame.height;
  bm:=tbitmap.create;
  bm.width:=w;
  bm.height:=h;
  bm2:=tbitmap.create;
  bm2.width:=w;
  bm2.height:=h;
  w2:=w div 2;
  h2:=h div 2 ;
  dx:=w2 div max ;
  dy:=h2 div max;
  x1  := w2- (factor * dx);
  y1 := h2- (factor *dy);
  x2 := w2+ (factor * dx);
  y2 := h2+(factor * dy);
  bm.canvas.Brush.color:=clblack;
  bm.canvas.Ellipse (x1,y1,x2,y2);
  bm.transparent:=true;
  bm.TransparentColor :=clblack;
  bm2.Assign (BitMapB);
  bm2.Canvas.Draw(0,0,bm);
  bm2.transparent:=true;
  bm2.TransparentColor :=clwhite;
  frame.canvas.draw(0,0,bm2);
  bm.free;
  bm2.free;
end;

Procedure TransPieLeft(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var w,h,dx,dy,w2,h2:integer;
    x1,y1,x2,y2,R:integer;
    Acolor:Tcolor;
    bm,bm2:tbitmap;
    angle:extended;//angle
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  bm:=tbitmap.create;
  bm.width:=w;
  bm.height:=h;
  bm2:=tbitmap.create;
  bm2.width:=w;
  bm2.height:=h;
  w2:=w div 2;
  h2:=h div 2 ;
  dx:=w2 div max ;
  dy:=h2 div max;
// wedge starts at 12 o'clock
  x1  := w2;
  y1 := 0;
// calculate end of wedge
  angle:=pi/2+factor*2*pi/max;
  if w2>h2 then
    R:=w2
    else
    R:=h2;
  x2 := round(w2+w2*cos(angle));
  y2 := round(h2-h2*sin(angle));
  bm.canvas.Brush.color:=clblack;
  bm.canvas.pie(0,0,w,h,x1,y1,x2,y2);
  bm.transparent:=true;
  bm.TransparentColor :=clblack;
  bm2.Assign (BitMapB);
  bm2.Canvas.Draw(0,0,bm);
  bm2.transparent:=true;
  bm2.TransparentColor :=clwhite;
  frame.canvas.draw(0,0,bm2);
  bm.free;
  bm2.free;
end;

Procedure TransPieRight(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var w,h,dx,dy,w2,h2:integer;
    x1,y1,x2,y2,R:integer;
    Acolor:Tcolor;
    bm,bm2:tbitmap;
    angle:extended;//angle
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  bm:=tbitmap.create;
  bm.width:=w;
  bm.height:=h;
  bm2:=tbitmap.create;
  bm2.width:=w;
  bm2.height:=h;
  w2:=w div 2;
  h2:=h div 2 ;
  dx:=w2 div max ;
  dy:=h2 div max;
// wedge starts at 12 o'clock
  x2  := w2;
  y2 := 0;
// calculate end of wedge
  angle:=pi/2-factor*2*pi/max;
  if w2>h2 then
    R:=w2
    else
    R:=h2;
  x1 := round(w2+w2*cos(angle));
  y1 := round(h2-h2*sin(angle));
  bm.canvas.Brush.color:=clblack;
  bm.canvas.pie(0,0,w,h,x1,y1,x2,y2);
  bm.transparent:=true;
  bm.TransparentColor :=clblack;
  bm2.Assign (BitMapB);
  bm2.Canvas.Draw(0,0,bm);
  bm2.transparent:=true;
  bm2.TransparentColor :=clwhite;
  frame.canvas.draw(0,0,bm2);
  bm.free;
  bm2.free;
end;

Procedure TransPieLeftRight(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var w,h,dx,dy,w2,h2:integer;
    x1,y1,x2,y2,R:integer;
    Acolor:Tcolor;
    bm,bm2:tbitmap;
    angle:extended;//angle
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  bm:=tbitmap.create;
  bm.width:=w;
  bm.height:=h;
  bm2:=tbitmap.create;
  bm2.width:=w;
  bm2.height:=h;
  w2:=w div 2;
  h2:=h div 2 ;
  dx:=w2 div max ;
  dy:=h2 div max;
// wedge starts at 12 o'clock
// calculate end of wedge
  if w2>h2 then
    R:=w2
    else
    R:=h2;
  angle:=pi/2-factor*pi/max;
  x1 := round(w2+w2*cos(angle));
  y1 := round(h2-h2*sin(angle));
  angle:=pi/2+factor*pi/max;
  x2 := round(w2+w2*cos(angle));
  y2 := round(h2-h2*sin(angle));

  bm.canvas.Brush.color:=clblack;
  bm.canvas.pie(0,0,w,h,x1,y1,x2,y2);
  bm.transparent:=true;
  bm.TransparentColor :=clblack;
  bm2.Assign (BitMapB);
  bm2.Canvas.Draw(0,0,bm);
  bm2.transparent:=true;
  bm2.TransparentColor :=clwhite;
  frame.canvas.draw(0,0,bm2);
  bm.free;
  bm2.free;
end;

Procedure TransChordTop(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var w,h,dx,dy,w2,h2:integer;
    x1,y1,x2,y2,R:integer;
    Acolor:Tcolor;
    bm,bm2:tbitmap;
    angle:extended;//angle
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  bm:=tbitmap.create;
  bm.width:=w;
  bm.height:=h;
  bm2:=tbitmap.create;
  bm2.width:=w;
  bm2.height:=h;
  w2:=w div 2;
  h2:=h div 2 ;
  dx:=w2 div max ;
  dy:=h2 div max;
// wedge starts at 12 o'clock
// calculate end of wedge
  if w2>h2 then
    R:=w2
    else
    R:=h2;
  angle:=pi/2-factor*pi/max;
  x1 := round(w2+w2*cos(angle));
  y1 := round(h2-h2*sin(angle));
  angle:=pi/2+factor*pi/max;
  x2 := round(w2+w2*cos(angle));
  y2 := round(h2-h2*sin(angle));
  bm.canvas.Brush.color:=clblack;
  bm.canvas.chord(0,0,w,h,x1,y1,x2,y2);
  bm.transparent:=true;
  bm.TransparentColor :=clblack;
  bm2.Assign (BitMapB);
  bm2.Canvas.Draw(0,0,bm);
  bm2.transparent:=true;
  bm2.TransparentColor :=clwhite;
  frame.canvas.draw(0,0,bm2);
  bm.free;
  bm2.free;
end;

Procedure TransChordLeft(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var w,h,dx,dy,w2,h2:integer;
    x1,y1,x2,y2,R:integer;
    Acolor:Tcolor;
    bm,bm2:tbitmap;
    angle:extended;//angle
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  bm:=tbitmap.create;
  bm.width:=w;
  bm.height:=h;
  bm2:=tbitmap.create;
  bm2.width:=w;
  bm2.height:=h;
  w2:=w div 2;
  h2:=h div 2 ;
  dx:=w2 div max ;
  dy:=h2 div max;
// wedge starts at 12 o'clock
// calculate end of wedge
  angle:=pi-factor*pi/max;
  x1 := round(w2+w2*cos(angle));
  y1 := round(h2-h2*sin(angle));
  angle:=pi+factor*pi/max;
  x2 := round(w2+w2*cos(angle));
  y2 := round(h2-h2*sin(angle));
  bm.canvas.Brush.color:=clblack;
  bm.canvas.chord(0,0,w,h,x1,y1,x2,y2);
  bm.transparent:=true;
  bm.TransparentColor :=clblack;
  bm2.Assign (BitMapB);
  bm2.Canvas.Draw(0,0,bm);
  bm2.transparent:=true;
  bm2.TransparentColor :=clwhite;
  frame.canvas.draw(0,0,bm2);
  bm.free;
  bm2.free;
end;

Procedure TransChordRight(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var w,h,dx,dy,w2,h2:integer;
    x1,y1,x2,y2,R:integer;
    Acolor:Tcolor;
    bm,bm2:tbitmap;
    angle:extended;//angle
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  bm:=tbitmap.create;
  bm.width:=w;
  bm.height:=h;
  bm2:=tbitmap.create;
  bm2.width:=w;
  bm2.height:=h;
  w2:=w div 2;
  h2:=h div 2 ;
  dx:=w2 div max ;
  dy:=h2 div max;
// wedge starts at 12 o'clock
// calculate end of wedge
  angle:=0-factor*pi/max;
  x1 := round(w2+w2*cos(angle));
  y1 := round(h2-h2*sin(angle));
  angle:=0+factor*pi/max;
  x2 := round(w2+w2*cos(angle));
  y2 := round(h2-h2*sin(angle));
  bm.canvas.Brush.color:=clblack;
  bm.canvas.chord(0,0,w,h,x1,y1,x2,y2);
  bm.transparent:=true;
  bm.TransparentColor :=clblack;
  bm2.Assign (BitMapB);
  bm2.Canvas.Draw(0,0,bm);
  bm2.transparent:=true;
  bm2.TransparentColor :=clwhite;
  frame.canvas.draw(0,0,bm2);
  bm.free;
  bm2.free;
end;

Procedure TransChordBottom(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var w,h,dx,dy,w2,h2:integer;
    x1,y1,x2,y2,R:integer;
    Acolor:Tcolor;
    bm,bm2:tbitmap;
    angle:extended;//angle
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  bm:=tbitmap.create;
  bm.width:=w;
  bm.height:=h;
  bm2:=tbitmap.create;
  bm2.width:=w;
  bm2.height:=h;
  w2:=w div 2;
  h2:=h div 2 ;
  dx:=w2 div max ;
  dy:=h2 div max;
// wedge starts at 12 o'clock
// calculate end of wedge
  angle:=-pi/2-factor*pi/max;
  x1 := round(w2+w2*cos(angle));
  y1 := round(h2-h2*sin(angle));
  angle:=-pi/2+factor*pi/max;
  x2 := round(w2+w2*cos(angle));
  y2 := round(h2-h2*sin(angle));
  bm.canvas.Brush.color:=clblack;
  bm.canvas.chord(0,0,w,h,x1,y1,x2,y2);
  bm.transparent:=true;
  bm.TransparentColor :=clblack;
  bm2.Assign (BitMapB);
  bm2.Canvas.Draw(0,0,bm);
  bm2.transparent:=true;
  bm2.TransparentColor :=clwhite;
  frame.canvas.draw(0,0,bm2);
  bm.free;
  bm2.free;
end;


Procedure TransBoxOut(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,d,d2,m,m2:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  m:=frame.Width div 2;
  d:=m div max ;
  m2:=frame.height div 2;
  d2:=m2 div max ;
  R.left  := m- (factor * d);
  R.Right := m+ ( factor * d);
  R.top := m2- (factor *d2);
  R.bottom:= m2+(factor * d2);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransBoxIn(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,d,d2,m,m2:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapB);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  m:=frame.Width div 2;
  d:=m div max ;
  m2:=frame.height div 2;
  d2:=m2 div max ;
  R.left  := factor * d;
  R.Right := frame.width-( factor * d);
  R.top := factor *d2;
  R.bottom:= frame.height-(factor * d2);
  frame.canvas.CopyRect (R,BitmapA.canvas,R);
end;

Procedure TransCrossIn(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,dx,dy:integer;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  dx:=(w div 2)div max;
  dy:=(h div 2) div max;
  R:=rect(0,0,factor*dx,factor*dy);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(w-factor*dx,0,w,factor*dy);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(0,h-factor*dy,factor*dx,h);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(w-factor*dx,h-factor*dy,w,h);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);

end;

Procedure TransCrossOut(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,dx,dy,w2,h2:integer;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  w2:=w div 2;
  h2:=h div 2;
  dx:=w2 div max;
  dy:=h2 div max;
  R:=rect(w2-factor*dx,0,w2+factor*dx,h);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(0,h2-factor*dy,w2-factor*dx,h2+factor*dy);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(w2+factor*dx,h2-factor*dy,w,h2+factor*dy);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;



Procedure TransDiagDR(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,dx,dy:integer;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  dx:=w div max;
  dy:=h div max;
  R:=rect(0,0,w,factor*dy);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(0,factor*dy,factor*dx,h);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransDiagDL(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,dx,dy:integer;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  dx:=w div max;
  dy:=h div max;
  R:=rect(0,0,w,factor*dy);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(w-factor*dx,factor*dy,w,h);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransDiagUR(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,dx,dy:integer;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  dx:=w div max;
  dy:=h div max;
  R:=rect(0,h-factor*dy,w,h);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(0,0,factor*dx,h-factor*dy);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransDiagUL(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,dx,dy:integer;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  w:=frame.width;
  h:=frame.height;
  dx:=w div max;
  dy:=h div max;
  R:=rect(0,h-factor*dy,w,h);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R:=rect(w-factor*dx,0,w,h-factor*dy);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransCurtainOpen(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,d,m:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  m:=frame.Width div 2;
  d:=m div max ;
  R.left  := m- (factor * d);
  R.Right := m+ ( factor * d);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransCurtainClose(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,d,m:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  m:=frame.Width div 2;
  d:=m div max ;
  R.right  := factor * d;
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R.right:=frame.width;
  R.left:=R.right- (factor * d);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);  
end;

Procedure TransCurtainVOpen(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,d,m:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  m:=frame.height div 2;
  d:=m div max ;
  R.top  := m- (factor * d);
  R.bottom := m+ ( factor * d);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransCurtainVClose(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h,d,m:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  m:=frame.height div 2;
  d:=m div max ;
  R.bottom  := factor * d;
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
  R.bottom:=frame.height;
  R.top:=R.bottom- (factor * d);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;


Procedure TransSlideRight(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.pixelformat:=pf24bit;
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  R.Right := round(Frame.width * factor / max);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransSlideLeft(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  R.left := Frame.width-(Frame.width * factor div max);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransSlideDown(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  R.Bottom := Frame.height * factor div max;
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;

Procedure TransSlideUp(
         const BitMapA:tbitmap;
         const BitmapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h:integer;
    Acolor:Tcolor;
begin
  frame.assign(BitmapA);
  frame.canvas.copymode:=cmsrccopy;
  R:=rect(0,0,frame.width,frame.height);
  R.Top :=Frame.height-( Frame.height * factor div max);
  frame.canvas.CopyRect (R,BitmapB.canvas,R);
end;


Procedure TransCompressHor(
         const BitMapA:tbitmap;
         factor,max:integer);
var R:trect;
    w,h:integer;
    Acolor:Tcolor;
begin
  frame.Width  := BitmapA.Width;
  frame.Height := BitmapA.Height;
  frame.PixelFormat :=pf24bit;
  Acolor:=BitmapA.Canvas.Pixels [0,0];
  R:=rect(0,0,frame.width,frame.height);
  frame.canvas.brush.color:=Acolor;
  frame.canvas.FillRect (R);
  w:=(BitmapA.width div max)*(max-factor);
  R.left:= (BitmapA.width-w) div 2;
  R.top:=0;
  R.Right:=BitmapA.width-R.left;
  R.bottom:=bitmapA.height;
  frame.Canvas.StretchDraw (R,BitmapA);
end;

procedure TransCompressVert(
         const BitMapA:tbitmap;
         factor,max:integer);
var R:trect;
    w,h:integer;
    Acolor:tcolor;
begin
  frame.Width  := BitmapA.Width;
  frame.Height := BitmapA.Height;
  frame.PixelFormat :=pf24bit;
  Acolor:=BitmapA.Canvas.Pixels [0,0];
  R:=rect(0,0,frame.width,frame.height);
  frame.canvas.brush.color:=Acolor;
  frame.canvas.FillRect (R);
  h:=(BitmapA.height div max)*(max-factor);
  R.top:= (BitmapA.height-h) div 2;
  R.left:=0;
  R.Right:=BitmapA.width;
  R.bottom:=bitmapA.height-R.top;
  frame.Canvas.StretchDraw (R,BitmapA);
end;


procedure TransExpandHor(
         const BitMapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h:integer;
    Acolor:Tcolor;
begin
  frame.Width  := BitmapB.Width;
  frame.Height := BitmapB.Height;
  frame.PixelFormat :=pf24bit;
  Acolor:=BitmapB.Canvas.Pixels [0,0];
  R:=rect(0,0,frame.width,frame.height);
  frame.canvas.brush.color:=Acolor;
  frame.canvas.FillRect (R);
  w:=(BitmapB.width div max)*factor;
  R.left:= (BitmapB.width-w) div 2;
  R.top:=0;
  R.Right:=BitmapB.width-R.left;
  R.bottom:=bitmapB.height;
  frame.Canvas.StretchDraw (R,BitmapB);
end;

procedure TransExpandVert(
         const BitMapB:tbitmap;
         factor,max:integer);
var R:trect;
    w,h:integer;
    Acolor:tcolor;
begin
  frame.Width  := BitmapB.Width;
  frame.Height := BitmapB.Height;
  frame.PixelFormat :=pf24bit;
  Acolor:=BitmapB.Canvas.Pixels [0,0];
  R:=rect(0,0,frame.width,frame.height);
  frame.canvas.brush.color:=Acolor;
  frame.canvas.FillRect (R);
  h:=(BitmapB.height div max)*factor;
  R.top:= (BitmapB.height-h) div 2;
  R.left:=0;
  R.Right:=BitmapB.width;
  R.bottom:=bitmapB.height-R.top;
  frame.Canvas.StretchDraw (R,BitmapB);
end;




procedure TMoviesF.FormCreate(Sender: TObject);
begin
//  Jansoft:=readpw;
  JanSoft:=true;
  SetProLite;
  appldir:=extractfilepath(application.exename);
  FrameNr:=1;
  FrameDraw:=false;
  Loops:=0;
  RotAngle:=90;
  // Do not use buffering.
  // This is safe since we have complete control over the TImage's canvas
  include(GIFImageDefaultDrawOptions, goDirectDraw);
  Frame:=tbitmap.create;
  wizfont:=TFont.Create;
  wizfont.Name:='Arial';
  wizfont.size:=12;
  wizText:=tstringlist.create;
  wiztext.text:='Movies';
  wizAccent:=clred;
  LoadSettings;

end;

procedure TMoviesF.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  // Zap GIF to stop display of animation (for safety)
  ImageAnimate.Picture.Graphic := nil;

end;

function TMoviesF.GetDelay(i:integer):integer;
begin
result:=strtointdef(list.items.values[list.items.names[i]],30);
end;

procedure TMoviesF.Createanimation(All:boolean);
var
  GIF			: TGIFImage;
  i			: integer;
  OptimizeOptions	: TGIFOptimizeOptions;
  ms                    : TMemorystream;
  im                    : Timage;
  CanAdd                : boolean;

  function TransparentIndex(GIF: TGIFSubImage): byte;
  begin
    // Use the lower left pixel as the transparent color
    Result := GIF.Pixels[0, GIF.Height-1];
  end;

  function AddBitmap(GIF: TGIFImage; Source: TGraphic; Transparent: boolean;
     FrameDelay:integer): integer;
  var
    Ext			: TGIFGraphicControlExtension;
    LoopExt		: TGIFAppExtNSLoop;
  begin
    // Preview the image being added (for user feedback)
    ImageAnimate.Picture.Assign(Source);
    ImageAnimate.Update;

    // Add the source image to the animation
    Result := GIF.Add(Source);
    // Netscape Loop extension must be the first extension in the first frame!
    if (Result = 0) then
    begin
      LoopExt := TGIFAppExtNSLoop.Create(GIF.Images[Result]);
      LoopExt.Loops := Loops; // Number of loops (0 = forever)
      GIF.Images[Result].Extensions.Add(LoopExt);
    end;
    // Add Graphic Control Extension
    Ext := TGIFGraphicControlExtension.Create(GIF.Images[Result]);
    Ext.Delay := FrameDelay; // Animation delay (30 = 300 mS)
    if (Transparent) then
    begin
      Ext.Transparent := True;
      Ext.TransparentColorIndex := TransparentIndex(GIF.Images[Result]);
    end;
    GIF.Images[Result].Extensions.Add(Ext);
  end;

begin
  Screen.Cursor := crHourGlass;
  try
    GIF := TGIFImage.Create;
    try
      // Add all the images in the scroll box to the animation
      for i := 0 to list.items.count-1 do begin
        if All then
          CanAdd:=true
        else
          CanAdd:=list.selected[i];
        if CanAdd then
        begin
        // Add frame
          im:=GetImage(i);
          Frame.assign(im.Picture.Graphic);
          PainterReduceF.externalconvert(frame);
            AddBitmap(GIF, // Destination GIF
              Frame, // Source bitmap
              im.transparent,   // frames are not transparent
              GetDelay(i)); //frame delay
        end;
      end;
      // Create a single global color map from multiple local color maps.
      // You don't *need* to do this, but it reduces the size of the file
      GIF.OptimizeColorMap;
      // Optimize GIF frames...
      OptimizeOptions := [];
      if (CheckBoxMerge.Checked) then
        include(OptimizeOptions, ooMerge);
      if (CheckBoxCrop.Checked) then
        include(OptimizeOptions, ooCrop);
      if (OptimizeOptions <> []) then
        GIF.Optimize(OptimizeOptions, GIFrm, GIFdm, 0);

      // Display the animation
      ImageAnimate.Picture.Assign(GIF);

      // Display the animation
      ImageAnimate.Picture.Assign(GIF);
    finally
      ms:=tmemorystream.Create ;
      Gif.SaveToStream (ms);
      anisize.Caption :=inttostr(ms.Size);
      ms.free;
      GIF.Free;
    end;
    SaveAs1.Enabled := True;
    SaveAs1.Caption :='Save GIF &As...';
    btnsaveani.Enabled :=true;
    btnsaveani.Caption :='GIF';
    Stop1.enabled:=true;
    btnstop.enabled:=true;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TMoviesF.AnimateWizList;
var
  GIF			: TGIFImage;
  i			: integer;
  OptimizeOptions	: TGIFOptimizeOptions;
  ms                    : TMemorystream;
  im                    : Timage;
  CanAdd                : boolean;
  function TransparentIndex(GIF: TGIFSubImage): byte;
  begin
    // Use the lower left pixel as the transparent color
    Result := GIF.Pixels[0, GIF.Height-1];
  end;

  function AddBitmap(GIF: TGIFImage; Source: TGraphic; Transparent: boolean;
     FrameDelay:integer): integer;
  var
    Ext			: TGIFGraphicControlExtension;
    LoopExt		: TGIFAppExtNSLoop;
  begin
    // Preview the image being added (for user feedback)
    ImageAnimate.Picture.Assign(Source);
    ImageAnimate.Update;

    // Add the source image to the animation
    Result := GIF.Add(Source);
    // Netscape Loop extension must be the first extension in the first frame!
    if (Result = 0) then
    begin
      LoopExt := TGIFAppExtNSLoop.Create(GIF.Images[Result]);
      LoopExt.Loops := 0; // Number of loops (0 = forever)
      GIF.Images[Result].Extensions.Add(LoopExt);
    end;
    // Add Graphic Control Extension
    Ext := TGIFGraphicControlExtension.Create(GIF.Images[Result]);
    Ext.Delay := FrameDelay; // Animation delay (30 = 300 mS)
    if (Transparent) then
    begin
      Ext.Transparent := True;
      Ext.TransparentColorIndex := TransparentIndex(GIF.Images[Result]);
    end;
    GIF.Images[Result].Extensions.Add(Ext);
  end;

begin
  Screen.Cursor := crHourGlass;
  try
    GIF := TGIFImage.Create;
    try
      // Add all the images in the scroll box to the animation
      for i := 0 to wizlist.count-1 do begin
        // Add frame
        wizlist.GetBitmap(i,frame);
        PainterReduceF.externalconvert(frame);
        AddBitmap(GIF, // Destination GIF
          Frame, // Source bitmap
          deftrans.Checked ,   // frames are not transparent
          FrameDelay); //frame delay
        end;
      // Create a single global color map from multiple local color maps.
      // You don't *need* to do this, but it reduces the size of the file
      GIF.OptimizeColorMap;
      // Optimize GIF frames...
      OptimizeOptions := [];
      if (CheckBoxMerge.Checked) then
        include(OptimizeOptions, ooMerge);
      if (CheckBoxCrop.Checked) then
        include(OptimizeOptions, ooCrop);
      if (OptimizeOptions <> []) then
        GIF.Optimize(OptimizeOptions, GIFrm, GIFdm, 0);

      // Display the animation
      ImageAnimate.Picture.Assign(GIF);

      // Display the animation
      ImageAnimate.Picture.Assign(GIF);
    finally
      ms:=tmemorystream.Create ;
      Gif.SaveToStream (ms);
      anisize.Caption :=inttostr(ms.Size);
      ms.free;
      GIF.Free;
    end;
    SaveAs1.Enabled := True;
    SaveAs1.Caption :='Save GIF &As...';
    btnsaveani.Enabled :=true;
    btnsaveani.Caption :='GIF';
    Stop1.enabled:=true;
    btnstop.enabled:=true;
  finally
    Screen.Cursor := crDefault;
  end;
end;


procedure TMoviesF.ButtonSaveClick(Sender: TObject);
begin
  // Set file extension and filter to GIF (or whatever is currently displayed)
  SaveDialog.DefaultExt := GraphicExtension(TGraphicClass(ImageAnimate.Picture.Graphic.ClassType));
  SaveDialog.Filter :=  GraphicFilter(TGraphicClass(ImageAnimate.Picture.Graphic.ClassType));
  // Prompt for filename
  if (SaveDialog.Execute) then
    ImageAnimate.Picture.SaveToFile(SaveDialog.Filename);
end;

procedure TMoviesF.ImageClick(Sender: TObject);
var i:integer;
    aname:string;
begin
  // Preview a source image
  Aname:=Timage(sender).name;
  list.itemindex:=list.items.indexof(Aname);
  listclick(sender);
end;

procedure TMoviesF.SetFrame(i:integer);
var R:trect;
begin
with GetImage(i)do begin
  picture.bitmap.width:=FrameWidth;
  picture.bitmap.height:=FrameHeight;
  Canvas.CopyMode :=cmsrccopy;
  R:=rect(0,0,FrameWidth,FrameHeight);
  Canvas.CopyRect (R,Frame.canvas,R);
  end;
end;

procedure TMoviesF.GetFrame(i:integer);
var R:trect;
begin
Frame.Canvas.CopyMode :=cmsrccopy;
R:=rect(0,0,FrameWidth,FrameHeight);
Frame.canvas.CopyRect (R,GetImage(i).canvas,R);
end;

procedure TMoviesF.ClearFrame;
var R:trect;
begin
Frame.width:=FrameWidth;
Frame.height:=FrameHeight;
Frame.Canvas.brush.color:=clwhite;
R:=rect(0,0,FrameWidth,FrameHeight);
Frame.canvas.fillrect(R);
end;


procedure TMoviesF.Duplicate;
var c,w,h,index:integer;
    aname,sdelay:string;
begin
index:=list.itemindex;
if index<0 then exit;
Sdelay:=inttostr(FrameDelay);
GetFrame(index);
Aname:='Frame'+inttostr(FrameNr);
inc(FrameNr);
if index=(list.items.count-1) then begin
  index:=list.items.add(Aname+'='+sdelay);
//  list.Checked [index]:=deftrans.Checked ;
  end
  else begin
  inc(index);
  list.items.insert(index,Aname+'='+sdelay);
//  list.Checked [index]:=deftrans.Checked ;
  end;
with Timage.create(self) do begin
   name:=Aname;
   parent:=scrollboxsource;
   top:=0;
   left:= (w+5)*index+2;
   width:=FrameWidth;
   Height:=FrameHeight;
   onmousedown:=IFramemousedown;
   ondblclick:=IFrameDblClick;
   popupmenu:=framepop;
   transparent:=deftrans.Checked;
   end;
SetFrame(index);
Arrange;
end;

procedure TMoviesF.InsertImage;
var c,w,h,index:integer;
    aname,sdelay:string;
begin
index:=list.itemindex;
if index<0 then exit;
Sdelay:=inttostr(FrameDelay);
Aname:='Frame'+inttostr(FrameNr);
inc(FrameNr);
if index=(list.items.count-1) then begin
  index:=list.items.add(Aname+'='+sdelay);
//  list.Checked [index]:=deftrans.Checked ;
  end
  else begin
  inc(index);
  list.items.insert(index,Aname+'='+sdelay);
//  list.Checked [index]:=deftrans.Checked ;
  end;
list.Selected [index]:=true;
with Timage.create(self) do begin
   name:=Aname;
   parent:=scrollboxsource;
   top:=0;
   left:= (w+5)*index+2;
   width:=FrameWidth;
   Height:=FrameHeight;
   onmousedown:=IFramemousedown;
   ondblclick:=IFrameDblClick;
   popupmenu:=framepop;
   transparent:=deftrans.checked;
   end;
SetFrame(index);
list.itemindex:=index;
Arrange;
end;


procedure TMoviesF.AddFrame(var GIF:Tgifimage;index:integer);
var c,w,h,i,delay:integer;
    afile,Aname,s,sdelay:string;
    trans:boolean;
begin
c:=list.items.count;
// afile:=files.filename;
delay:=FrameDelay;
trans:=deftrans.Checked ;
Frame.Assign (GIF.images[index]);
w:=frame.width;
h:=frame.height;
if c=0 then begin
  FrameWidth:=w;
  FrameHeight:=h;
  end;
// check extensions
 if (GIF.Images[Index].Extensions.Count > 0) then
   for i := 0 to GIF.Images[Index].Extensions.Count-1 do begin
     if (GIF.Images[index].Extensions[i] is TGIFGraphicControlExtension) then begin
      delay:=TGIFGraphicControlExtension(
        GIF.Images[index].Extensions[i]).delay;
      trans:=TGIFGraphicControlExtension(
        GIF.Images[index].Extensions[i]).transparent;
        end;
      end;
Sdelay:=inttostr(delay);
if ((w<>FrameWidth) or (h<>FrameHeight)) then exit;
with Timage.create(self) do begin
   Aname:='Frame'+inttostr(FrameNr);
   inc(FrameNr);
   name:=Aname;
   parent:=scrollboxsource;
   top:=0;
   left:= (w+5)*c;
   width:=FrameWidth;
   Height:=FrameHeight;
   picture.Assign (frame);
   onmousedown:=IFramemousedown;
   popupmenu:=framepop;
   ondblclick:=IFrameDblClick;
   transparent:=trans;
  i:=list.items.Add (Aname+'='+Sdelay);
//  list.Checked [i]:=trans;
  end;
end;

procedure TMoviesF.Add1Click(Sender: TObject);
var c,w,h,index:integer;
    inext,afile,Aname,s,sdelay:string;
    mygif:tgifimage;
    myjpg:tJpegImage;
    myIcon:TIcon;
    bm:tbitmap;
    R:trect;
begin
c:=list.items.count;
if files.ItemIndex <0 then exit;
afile:=files.filename;
inext:=uppercase(extractfileext(afile));
  if inext='.GIF' then
    begin
    mygif:=Tgifimage.create;
    mygif.LoadFromFile (afile);
    frame.Assign (mygif);
    mygif.Free ;
    end
   else if (inext='.JPG') or (inext='.JPEG') then
    begin
    myjpg:=Tjpegimage.create;
    myjpg.LoadFromFile (afile);
    frame.Assign (myjpg);
    myjpg.Free ;
    end
   else if inext='.ICO' then
    begin
    myicon:=TIcon.create;
    myicon.LoadFromFile (afile);
    frame.Width :=myicon.Width ;
    frame.height :=myicon.Height;
    frame.canvas.Draw (0,0,myicon);
    myicon.Free ;
    end
  else if inext='.BMP' then
    begin
    Frame.LoadFromFile (afile);
    end
    else exit;

Sdelay:=inttostr(FrameDelay);

w:=frame.width;
h:=frame.height;
if c=0 then begin
  FrameWidth:=w;
  FrameHeight:=h;
  end;
if ((w<>FrameWidth) or (h<>FrameHeight)) then begin
  bm:=tbitmap.create;
  bm.width:=FrameWidth;
  bm.height:=FrameHeight;
  bm.PixelFormat :=pf24bit;
  R:=rect(0,0,FrameWidth,FrameHeight);
  R:=importRect(R,w,h);
  bm.canvas.StretchDraw (R,frame);
  frame.Assign (bm);
//  showmessage('Incorrect ImageSize');
  bm.free;
  end;
with Timage.create(self) do begin
   Aname:='Frame'+inttostr(FrameNr);
   inc(FrameNr);
   name:=Aname;
   parent:=scrollboxsource;
   top:=0;
   left:= (w+5)*c;
   width:=FrameWidth;
   Height:=FrameHeight;
   picture.Assign (frame);
   onmousedown:=IFramemousedown;
   popupmenu:=framepop;
   ondblclick:=IFrameDblClick;
  index:=list.items.Add (Aname+'='+Sdelay);
//  list.Checked [index]:=deftrans.Checked ;
   transparent:=deftrans.checked;
  end;
end;

function TMoviesF.importRect(R:Trect;w,h:integer):Trect;
var rw,rh,iw,ih,dh,dw:integer;
begin
  rw:=R.right-R.left;
  rh:=R.bottom-R.top;
 if w>h then begin
  ih:=round(h/w*rw);
  dh:=(rh-ih)div 2;
  result:=rect(R.left,R.top+dh,R.right,R.bottom-dh);
  end
  else begin
  iw:=round(w/h*rh);
  dw:=(rw-iw) div 2;
  result:=rect(R.left+dw,R.top,R.right-dw,R.bottom);
  end;
end;

procedure TMoviesF.Delete1Click(Sender: TObject);
var index:integer;
begin
if list.SelCount >0 then
 repeat
  for index:=0 to list.Items.Count -1 do
   if list.Selected [index] then begin
    GetImage(index).free;
    list.items.delete(index);
    break;
    end;
 until list.selcount=0;
arrange;
end;

procedure TMoviesF.ListDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
accept:=source=list;
end;

procedure TMoviesF.arrange;
var i:integer;
begin
if list.items.count=0 then exit;
for i:=0 to list.items.count-1 do begin
  GetImage(i).left:=(FrameWidth+5)*i;
  end;
end;

procedure TMoviesF.ListDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var index,item:integer;
begin
if source=list  then begin
  index:=list.itemindex;
  if index<0 then exit;
  item:=list.ItemAtPos (point(x,y),true);
  if item<0 then exit;
  list.items.Move (index,item);
  Arrange;
  end;
end;

function TMoviesF.GetImage(i:integer):Timage;
begin
result:=Timage(findcomponent(list.items.names[i]));
end;

procedure TMoviesF.ListClick(Sender: TObject);
var index,Aleft,p:integer;
    Aname:String;
begin
index:=list.itemindex;
if index<0 then exit;
Aleft:=GetImage(index).left;
FramePointer.caption:=list.items[index];
Framepointer.left:=Aleft+(FrameWidth div 2)-(FramePointer.Width div 2);
Scrollboxsource.ScrollInView (GetImage(index));
Framepointer.bringtofront;
end;

procedure TMoviesF.Up1Click(Sender: TObject);
var w,h,i,j,linebytes,index:integer;
    line:Pbytearray;
    r:Trect;
begin
index:=list.itemindex;
if index<0 then exit;
frame.canvas.draw(0,0,GetImage(index).picture.bitmap);
w:=framewidth;
h:=frameheight;
linebytes:=abs(integer(frame.scanline[1])-
   integer(frame.scanline[0]));
line:=allocmem(linebytes);
move((frame.scanline[0])^,line^,linebytes);
for j:=1 to h-1 do
  move((frame.scanline[j])^,(frame.scanline[j-1])^,linebytes);
move(line^,(frame.scanline[h-1])^,linebytes);
GetImage(index).picture.bitmap.canvas.draw(0,0,frame);
end;

procedure TMoviesF.Down1Click(Sender: TObject);
var w,h,i,j,linebytes,index:integer;
    line:Pbytearray;
    r:Trect;
begin
index:=list.itemindex;
if index<0 then exit;
frame.canvas.draw(0,0,GetImage(index).picture.bitmap);
w:=framewidth;
h:=frameheight;
linebytes:=abs(integer(frame.scanline[1])-
   integer(frame.scanline[0]));
line:=allocmem(linebytes);
move((frame.scanline[h-1])^,line^,linebytes);
for j:=h-2 downto 0 do
  move((frame.scanline[j])^,(frame.scanline[j+1])^,linebytes);
move(line^,(frame.scanline[0])^,linebytes);
GetImage(index).picture.bitmap.canvas.draw(0,0,frame);
end;

procedure TMoviesF.Left1Click(Sender: TObject);
var w,h,i,j,index:integer;
    line:Pbytearray;
    cr,cg,cb:byte;
begin
index:=list.itemindex;
if index<0 then exit;
frame.canvas.draw(0,0,GetImage(index).picture.bitmap);
frame.PixelFormat :=pf24bit;
w:=framewidth;
h:=frameheight;
for j:=0 to h-1 do begin
  line:=frame.scanline[j];
  cr:=line[0];
  cg:=line[1];
  cb:=line[2];
  for i:=1 to w-1 do begin
    line[(i-1)*3]:=line[i*3];
    line[(i-1)*3+1]:=line[i*3+1];
    line[(i-1)*3+2]:=line[i*3+2];
    end;
  line[(w-1)*3]:=cr;
  line[(w-1)*3+1]:=cg;
  line[(w-1)*3+1]:=cb;
  end;
GetImage(index).picture.bitmap.canvas.draw(0,0,frame);
end;

procedure TMoviesF.Right1Click(Sender: TObject);
var w,h,i,j,index:integer;
    line:Pbytearray;
    cr,cg,cb:byte;
begin
index:=list.itemindex;
if index<0 then exit;
frame.canvas.draw(0,0,GetImage(index).picture.bitmap);
frame.PixelFormat :=pf24bit;
w:=framewidth;
h:=frameheight;
for j:=0 to h-1 do begin
  line:=frame.scanline[j];
  cr:=line[(w-1)*3];
  cg:=line[(w-1)*3+1];
  cb:=line[(w-1)*3+2];
  for i:=w-2 downto 0 do begin
    line[(i+1)*3]:=line[i*3];
    line[(i+1)*3+1]:=line[i*3+1];
    line[(i+1)*3+2]:=line[i*3+2];
    end;
  line[0]:=cr;
  line[1]:=cg;
  line[2]:=cb;
  end;
Getimage(index).picture.bitmap.canvas.draw(0,0,frame);
end;

procedure TMoviesF.Duplicate1Click(Sender: TObject);
begin
Duplicate;
end;

procedure TMoviesF.Invert1Click(Sender: TObject);
var w,h,i,j,linebytes,index:integer;
    line:Pbytearray;
    bm:tbitmap;
begin
index:=list.itemindex;
if index<0 then exit;
bm:=GetImage(index).picture.bitmap;
frame.width:=bm.width;
frame.height:=bm.height;
frame.pixelformat:=pf24bit;
frame.canvas.draw(0,0,bm);
janFX.Invert (frame);
bm.canvas.draw(0,0,frame);
list.invalidate;
end;

procedure TMoviesF.Contents1Click(Sender: TObject);
begin
application.HelpFile :=appldir+'Movies.hlp';
application.HelpJump ('Movies');

end;

procedure TMoviesF.About1Click(Sender: TObject);
begin
showmessage('Movies 12 by Jan Verhoeven'+cr
   +'Created with Delphi 5'+cr+cr
   +'Email: jan1.verhoeven@wxs.nl'+cr+cr
   +'Updates: http://jansfreeware.com');

end;

procedure TMoviesF.clear;
var index,i:integer;
begin
if list.items.count=0 then exit;
  for i:=0 to list.items.count-1 do
    GetImage(i).free;
  list.items.Clear ;
  FrameNr:=1;
  FramePointer.left:=40;
  FramePointer.top:=80;
  with ScrollboxSource.HorzScrollBar do begin
//   Range :=43;
   position:=0;
   end;
end;

procedure TMoviesF.DeleteAll;
var index,i:integer;
begin
if list.items.count=0 then exit;
  for i:=0 to list.items.count-1 do
    GetImage(i).free;
  list.items.Clear ;
  FrameNr:=1;
  FramePointer.left:=40;
  FramePointer.top:=80;
  ScrollboxSource.HorzScrollBar.position:=0;
end;

procedure TMoviesF.Stop1Click(Sender: TObject);
begin
Imageanimate.Picture.Assign (Frame);
    Stop1.enabled:=false;
    btnstop.enabled:=false;
    SaveAs1.Caption :='Save BMP &As...';    
    btnsaveani.caption:='BMP';
end;

procedure TMoviesF.IFrameDblClick(Sender: TObject);
var Aname:string;
    im:Timage;
begin
  Aname:=Timage(sender).name;
  list.itemindex:=list.items.indexofname(Aname);
  listclick(sender);
  im:=Timage(sender);
  with DrawF.pic do begin
    width:=im.width;
    height:=im.height;
    picture.bitmap.width:=im.width;
    picture.bitmap.height:=im.height;
    canvas.draw(0,0,im.picture.bitmap);
    end;
  if DrawF.showmodal=mrOK then begin
    DrawF.zoom1Click (sender);
    im.canvas.Draw (0,0,
      DrawF.pic.picture.bitmap);
//    im.picture.Bitmap.PixelFormat :=pf8bit;  
    list.invalidate ;
    end
end;


procedure TMoviesF.IFrameMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Aname:string;
begin
  Aname:=Timage(sender).name;
  list.itemindex:=list.items.indexofname(Aname);
  selectnone;
  list.Selected [list.itemindex]:=true;
  listclick(sender);
end;

procedure TMoviesF.selectnone;
var i:integer;
begin
if list.items.count=0 then exit;
 for i:=0 to list.items.count-1 do
   list.Selected [i]:=false;
end;

procedure TMoviesF.goNewClick(Sender: TObject);
var s,sdelay,Aname:string;
    index:integer;
begin
if list.items.count=0 then begin
  s:=inttostr(DefaultWidth);
  s:=inputbox('Movies Frames','Enter Width',s);
  try
    FrameWidth:=strtoint(s);
    except
    exit;
    end;
  s:=inttostr(DefaultHeight);
  s:=inputbox('Movies Frames','Enter Height',s);
  try
    FrameHeight:=strtoint(s);
    except
    exit;
    end;
  end;
DefaultWidth:=FrameWidth;
Defaultheight:=FrameHeight;
Sdelay:=inttostr(FrameDelay);
Aname:='Frame'+inttostr(FrameNr);
inc(FrameNr);
  if (list.items.count=0) or (list.itemindex=-1) then
   index:=list.items.add(Aname+'='+sdelay)
  else if (list.itemindex=list.items.count-1) then
   index:=list.items.add(Aname+'='+sdelay)
  else begin
   list.items.Insert(list.itemindex+1,Aname+'='+sdelay);
   index:=list.itemindex+1;
  end;
//list.Checked [index]:=deftrans.Checked ;
with Timage.create(self) do begin
   name:=Aname;
   parent:=scrollboxsource;
   top:=0;
   left:= (FrameWidth+5)*index+2;
   width:=FrameWidth;
   Height:=FrameHeight;
   onmousedown:=IFramemousedown;
   ondblclick:=IFrameDblClick;
   popupmenu:=framepop;
   transparent:=deftrans.Checked ;
   end;
  list.itemindex:=index;
  ClearFrame;
  SetFrame(index);
  Arrange;
end;

procedure TMoviesF.Append;
var s,sdelay,Aname:string;
    index:integer;
begin
Sdelay:=inttostr(FrameDelay);
Aname:='Frame'+inttostr(FrameNr);
inc(FrameNr);
index:=list.items.add(Aname+'='+sdelay);
//list.Checked [index]:=deftrans.Checked ;
with Timage.create(self) do begin
   name:=Aname;
   parent:=scrollboxsource;
   top:=0;
   left:= (FrameWidth+5)*index+2;
   width:=FrameWidth;
   Height:=FrameHeight;
   onmousedown:=IFramemousedown;
   popupmenu:=framepop;
   ondblclick:=IFrameDblClick;
   transparent:=deftrans.Checked ;
   picture.bitmap.Assign(
        PainterEffectsF.image.picture.bitmap);

   end;
  list.itemindex:=index;
//  ClearFrame;
//  SetFrame(index);
//  Arrange;
end;


procedure TMoviesF.Caption1Click(Sender: TObject);
var s:string;
begin
end;

procedure TMoviesF.Rotate(Sender: TObject);
var bm,bmp:tbitmap;
    theangle:real;
    cx,cy:integer;
begin
if list.itemindex=-1 then exit;
bm:=(GetImage(list.itemindex).picture.bitmap);
bm.PixelFormat :=pf24bit;
bmp:=tbitmap.create;
bmp.width:=bm.width;
bmp.height:=bm.height;
bmp.canvas.draw(0,0,bm);
bmp.pixelformat:=pf24bit;
cx:=bmp.width div 2;
cy:=bmp.height div 2;
janFX.SmoothRotate (bm,bmp,cx,cy,RotAngle);
bm.assign(bmp);
bmp.free;
end;

procedure TMoviesF.SaveAs2Click(Sender: TObject);
var im:timage;
    afile:string;
begin
if framepop.popupcomponent=list then begin
  if list.itemindex<>-1 then
  im:=GetImage(list.itemindex)
  else exit;
  end
  else
  im:=TImage(framepop.popupcomponent);
if savedialog1.execute then begin
  afile:=changefileext(savedialog1.filename,'.bmp');
  with im do begin
    picture.Bitmap.SaveToFile (afile);
    end;
  end;
list.invalidate;  
end;

procedure TMoviesF.Trace(Sender: TObject);
var
  x,y : integer;
  bm,BitMap : TBitMap;
  P1,P2 : PByteArray;
begin
if list.itemindex=-1 then exit;
  bm:=GetImage(list.itemindex).picture.bitmap;
  BitMap := TBitMap.create;
  Bitmap.width:=bm.Width ;
  Bitmap.height:=bm.height;
  Bitmap.canvas.draw(0,0,bm);
  janFX.Trace (Bitmap,1);
  bm.Assign (Bitmap);
  BitMap.free;
list.invalidate;  
end;


procedure TMoviesF.RotationAngle1Click(Sender: TObject);
var s:string;
begin
s:=inputbox('Movies Frame Rotation','Enter Angle',inttostr(RotAngle));
Rotangle:=strtointdef(s,90);
end;

procedure TMoviesF.Delay1Click(Sender: TObject);
var index,d:integer;
    s:string;
begin
index:=list.itemindex;
if index<0 then exit;
s:=list.items.values[list.items.names[index]];
s:=inputbox('Movies Frame Delays','Enter Delay (10..255)',s);
d:=strtointdef(s,30);
if ((d>=10) and (d<=255)) then begin
  list.items.values[list.items.names[index]]:=s;
  end;
FramePointer.caption:=list.items[index];  
end;

procedure TMoviesF.initwizlist;
begin
wizlist.Clear ;
wizlist.Width :=Framewidth;
wizlist.height:=FrameHeight;
end;

procedure TMoviesF.DoWizard(Astyle:Twizardstyle);
  VAR
    Bitmap,BMA,BMB:  TBitmap;
    rx,ry,i,index,cx,cy,w,h,x,y,dr,dx,dy     :  INTEGER;
    am:extended;
    R,SpotR:trect;
    s:string;
    pt:TPoint;
begin
initwizlist;
index:=list.itemindex;
if ((index<0) or (index>(list.items.count-2))) then exit;
w:=FrameWidth;
h:=Frameheight;
R:=rect(0,0,w,h);
BMA:=Tbitmap.create;
BMA.width:=w;
BMA.height:=h;
BMA.canvas.draw(0,0,GetImage(index).picture.bitmap);
BMA.PixelFormat :=pf24bit;
BMB:=Tbitmap.create;
BMB.width:=FrameWidth;
BMB.height:=FrameHeight;
BMB.canvas.draw(0,0,GetImage(index+1).picture.bitmap);
BMB.PixelFormat :=pf24bit;
frame.Width :=w;
frame.Height :=h;
cx:= w div 2;
cy:= h div 2;
frame.PixelFormat :=pf24bit;
  Screen.Cursor := crHourGlass;
  TRY
    FOR i := 1 TO TransFrames DO
    BEGIN
      case Astyle of
        wsTransition: CreateTweenBitmap(BMA, TransFrames-i, BMB, i);
        wsrotateleftright: TransCompressHor(BMA,i,TransFrames);
        wsRotateTopDown: TransCompressVert(BMA,i,TransFrames);
        wsBlindsDown: TransBlinds(BMA,BMB,i,TransFrames);
        wsBlindsRight: TransBlindsHor(BMA,BMB,i,TransFrames);
        wsCheckerHor: TransCheckerHor(BMA,BMB,i,TransFrames);
        wsMarqueeUp: TransMarqueeUp(BMA,BMB,i,TransFrames);
        wsMarqueeDown: TransMarqueeDown(BMA,BMB,i,TransFrames);
        wsMarqueeUpDown: TransMarqueeUp(BMA,BMB,i,TransFrames);
        wsMarqueeLeft: TransMarqueeLeft(BMA,BMB,i,TransFrames);
        wsMarqueeRight: TransMarqueeRight(BMA,BMB,i,TransFrames);
        wsMarqueeLeftRight: TransMarqueeLeft(BMA,BMB,i,TransFrames);
        wsWipeRight: TransSlideRight(BMA,BMB,i,TransFrames);
        wsWipeleft: TransSlideLeft(BMA,BMB,i,TransFrames);
        wsWipeDown: TransSlideDown(BMA,BMB,i,TransFrames);
        wsWipeUp: TransSlideUp(BMA,BMB,i,TransFrames);
        wsCurtainOH: TransCurtainOpen(BMA,BMB,i,TransFrames);
        wsCurtainCH: TransCurtainClose(BMA,BMB,i,TransFrames);
        wsCurtainOV: TransCurtainVOpen(BMA,BMB,i,TransFrames);
        wsCurtainCV: TransCurtainVClose(BMA,BMB,i,TransFrames);
        wsBoxIn: TransBoxIn(BMA,BMB,i,TransFrames);
        wsBoxOut: TransBoxOut(BMA,BMB,i,TransFrames);
        wsDiagonalDR: TransDiagDR(BMA,BMB,i,TransFrames);
        wsDiagonalDL: TransDiagDL(BMA,BMB,i,TransFrames);
        wsDiagonalUR: TransDiagUR(BMA,BMB,i,TransFrames);
        wsDiagonalUL: TransDiagUL(BMA,BMB,i,TransFrames);
        wsCrossIn: TransCrossIn(BMA,BMB,i,TransFrames);
        wsCrossOut: TransCrossOut(BMA,BMB,i,TransFrames);
        wsCircleOut: TransCircOut(BMA,BMB,i,TransFrames);
        wsSweepLeft: TransPieLeft(BMA,BMB,i,TransFrames);
        wsSweepRight: TransPieRight(BMA,BMB,i,TransFrames);
        wsSegmentTop: TransChordTop(BMA,BMB,i,TransFrames);
        wsSegmentLeft: TransChordLeft(BMA,BMB,i,TransFrames);
        wsSegmentRight: TransChordRight(BMA,BMB,i,TransFrames);
        wsSegmentBottom: TransChordBottom(BMA,BMB,i,TransFrames);
        wsSweepLR: TransPieLeftRight(BMA,BMB,i,TransFrames);
        wsSmoothRotate : janFX.SmoothRotate (BMA,frame,cx,cy,i/transframes*360);
        wsFishEye: janFX.FishEye(BMA,frame,(55+ i/transframes*45)/100);
        wsWings: janFX.marble(BMA,frame,round(1+i/TransFrames*100),100);
        wsSplitBlur:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.SplitBlur (frame,round(i/transframes*20));
          end;
        wsFoldRight: janFX.FoldRight(BMA,BMB,frame,i/transframes);
        wsGaussianBlur:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.GaussianBlur(frame,round(i/transframes*20));
          end;
        wsTwist: janFX.Twist (BMA,frame,round(1+i/Transframes*50));
        wsSqueezeTop: janFX.squeezehor(BMA,frame,round(i/Transframes*100),mbTop);
        wsSqueezeBottom: janFX.squeezehor(BMA,frame,round(i/Transframes*100),mbBottom);
        wsSqueezeDiamond: janFX.squeezehor(BMA,frame,round(i/Transframes*100),mbDiamond);
        wsSqueezeWaste: janFX.squeezehor(BMA,frame,round(i/Transframes*100),mbWaste);
        wsSqueezeRound: janFX.squeezehor(BMA,frame,round(i/Transframes*100),mbRound);
        wsSqueezeRound2:janFX.squeezehor(BMA,frame,round(i/Transframes*100),mbRound2);
        wsMaskMandelBrot:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.MaskMandelBrot(frame,round(i/Transframes*40));
          end;
        wsFilterBlue:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.FilterBlue(frame,0,round(i/Transframes*255));
          end;
        wsFilterGreen:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.FilterGreen(frame,0,round(i/Transframes*255));
          end;
        wsFilterRed:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.FilterRed(frame,0,round(i/Transframes*255));
          end;
        wsKeepBlue:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.KeepBlue(frame,i/Transframes);
          end;
        wsKeepGreen:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.KeepGreen(frame,i/Transframes);
          end;
        wsKeepRed:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.KeepRed(frame,i/Transframes);
          end;
        wsColorNoise:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.AddColorNoise(frame,round(i/Transframes*200));
          end;
        wsMonoNoise:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.AddMonoNoise(frame,round(i/Transframes*200));
          end;
        wsBrightness:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.Lightness (Frame,round(i/Transframes*100));
          end;
        wsButtonize:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.Buttonize(Frame,round(0.3*h*i/transframes),20);
          end;
        wsDancespot:
          begin
          Frame.canvas.draw(0,0,BMA);
          x:=random(2*w div 3);
          y:=random(2*h div 3);
          if i=1 then begin
            dr:=random(h div 2);
            frame.canvas.pen.style:=psclear;
          end;
          frame.canvas.brush.color:=wizaccent;
          frame.canvas.Ellipse(x,y,x+dr,y+dr);
          end;
        wsSplitLight:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.splitlight(frame,round(i/Transframes*10));
          end;
        wsSplitLightReverse:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.splitlight(frame,round(1+(1-i/Transframes)*9));
          end;
        wsContrast:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.Contrast(Frame,round(i/Transframes*100));
          end;
        wsSaturation:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.Saturation(Frame,round(i/Transframes*255));
          end;
        wsMozaic:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.Mosaic(frame,round(2+i/Transframes*30));
          end;
        wsTexTile:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.TexturizeTile(frame,round(3+i/Transframes*min(h,w)/2));
          end;
        wsTexOverlap:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.TexturizeOverlap(frame,round(3+i/Transframes*min(h,w)/2));
          end;
        wsTriangles:
          begin
          Frame.canvas.draw(0,0,BMA);
          janFX.Triangles(frame,round(5+i/Transframes*max(h,w)));
          end;
        wsTile: janFX.Tile(BMA,frame,i);
        wsGrowCenter:
          begin
          am:=i/Transframes;
          x:=(w-round(am*w))div 2;
          y:=(h-round(am*h))div 2;
          janFX.Grow (BMA,BMB,frame,am,x,y);
          end;
        wsShrinkCenter:
          begin
          am:=1-0.9*i/Transframes;
          x:=(w-round(am*w))div 2;
          y:=(h-round(am*h))div 2;
          janFX.Grow (BMA,BMB,frame,am,x,y);
          end;
        wsGrowTop:
          begin
          am:=i/Transframes;
          x:=(w-round(am*w))div 2;
          y:=0;
          janFX.Grow (BMA,BMB,frame,am,x,y);
          end;
        wsShrinkTop:
          begin
          am:=1-0.9*i/Transframes;
          x:=(w-round(am*w))div 2;
          y:=0;
          janFX.Grow (BMA,BMB,frame,am,x,y);
          end;
        wsGrowBottom:
          begin
          am:=i/Transframes;
          x:=(w-round(am*w))div 2;
          y:=(h-round(am*h));
          janFX.Grow (BMA,BMB,frame,am,x,y);
          end;
        wsShrinkBottom:
          begin
          am:=1-0.9*i/Transframes;
          x:=(w-round(am*w))div 2;
          y:=(h-round(am*h));
          janFX.Grow (BMA,BMB,frame,am,x,y);
          end;
        wsFadeIn:
          begin
          frame.canvas.draw(0,0,BMA);
          janFX.Darkness (Frame,round((1-i/Transframes)*255));
          end;
        wsFadeInOut:
          begin
          frame.canvas.draw(0,0,BMA);
          janFX.Darkness (Frame,round((1-i/Transframes)*255));
          end;
        wsFadeOut:
          begin
          frame.canvas.draw(0,0,BMA);
          janFX.Darkness (Frame,round(i/Transframes*255));
          end;
        wsSpot:
          begin
          frame.canvas.draw(0,0,BMA);
          cx:=round(i/Transframes*w);
          cy:=h div 4;
          SpotR:=rect(cx,cy,cx+(h div 2),cy+(h div 2));
          janFX.SpotLight(Frame,0,spotR);
          end;
        wsSpotFade:
          begin
          frame.canvas.draw(0,0,BMA);
          cx:=round(i/Transframes*w);
          cy:=h div 4;
          SpotR:=rect(cx,cy,cx+(h div 2),cy+(h div 2));
          janFX.SpotLight(Frame,round((1-i/Transframes)*255),spotR);
          end;
        wsSpotLarge:
          begin
          frame.canvas.draw(0,0,BMA);
          cx:=round(i/Transframes*w);
          cy:=h div 6;
          SpotR:=rect(cx,cy,cx+(2*h div 3),cy+(2*h div 3));
          janFX.SpotLight(Frame,0,spotR);
          end;
        wsSpotLargeFade:
          begin
          frame.canvas.draw(0,0,BMA);
          cx:=round(i/Transframes*w);
          cy:=h div 6;
          SpotR:=rect(cx,cy,cx+(2*h div 3),cy+(2*h div 3));
          janFX.SpotLight(Frame,round((1-i/Transframes)*255),spotR);
          end;
        wsShake: janFX.Shake (BMA,frame,i/TransFrames*0.5);
        wsShakeDown: janFX.ShakeDown (BMA,frame,i/TransFrames*0.5);
        wsPlasmaSmall: janFX.Plasma (BMA,BMB,frame,i/TransFrames*(h div 4),64);
        wsPlasmaLarge: janFX.Plasma (BMA,BMB,frame,i/TransFrames*(h div 2),64);
        wsPlasmaTurbo: janFX.Plasma (BMA,BMB,frame,i/TransFrames*(h div 2),32);
        wsPlasmaXLarge: janFX.Plasma (BMA,BMB,frame,i/TransFrames*((2* h) div 3),64);
        wsTextType:
          begin
            Frame.canvas.font.Assign(wizfont);
            Frame.canvas.brush.style:=bssolid;
            Frame.canvas.draw(0,0,BMA);
            Frame.canvas.brush.style:=bsclear;
            s:=copy(wiztext[0],1,i);
            Frame.canvas.TextOut(wizpos.x,wizpos.y,s);
          end;
        wsTextGrow:
          begin
            Frame.canvas.brush.style:=bssolid;
            Frame.canvas.draw(0,0,BMA);
            Frame.canvas.brush.style:=bsclear;
            if i=1 then
              Frame.canvas.font.Assign(wizfont)
            else
              Frame.canvas.font.Size:=trunc(1.1*Frame.canvas.font.Size);
            Frame.canvas.TextOut(wizpos.x,wizpos.y,wiztext[0]);
          end;
        wsTextmarquee:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             Frame.canvas.brush.style:=bsclear;
             Frame.canvas.font.Assign(wizfont);
             Frame.canvas.TextOut(w-round(i/transframes*w)+wizpos.x,wizpos.y,wiztext[0]);
          end;
        wsTextLines:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             Frame.canvas.brush.style:=bsclear;
             Frame.canvas.font.Assign(wizfont);
             if wiztext.count<>0 then
             begin
               if (i-1)<wiztext.count then
                 Frame.canvas.TextOut(wizpos.x,wizpos.y,wiztext[i-1])
               else
                 Frame.canvas.TextOut(wizpos.x,wizpos.y,wiztext[wiztext.count-1]);
             end;
          end;
        wsTextAccent: TextAccent(Frame,BMA,i,transframes);
        wsActorRight:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
               Frame.canvas.draw(round(i/transframes*w)+wizpos.x,wizpos.y,DrawF.actor.picture.bitmap);
          end;
        wsActorDown:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
               Frame.canvas.draw(wizpos.x,round(i/transframes*h)+wizpos.y,DrawF.actor.picture.bitmap);
          end;
        wsActorLeft:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
               Frame.canvas.draw(w-round(i/transframes*w)+wizpos.x,wizpos.y,DrawF.actor.picture.bitmap);
          end;
        wsActorUp:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
               Frame.canvas.draw(wizpos.x,h-round(i/transframes*h)+wizpos.y,DrawF.actor.picture.bitmap);
          end;
        wsActorPath:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
               if (high(actorpath)>0) and (i<=high(actorpath)) then
                 Frame.canvas.draw(actorpath[i].x,actorpath[i].y,DrawF.actor.picture.bitmap);
          end;
        wsActorCircleLeft:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
             begin
               dx:=DrawF.actor.picture.bitmap.width div 2;
               dy:=DrawF.actor.picture.bitmap.height div 2;
               cx:=w div 2;
               cy:=h div 2;
               pt.x:=cx +trunc((cx-dx)*cos(i/transframes*2*pi));
               pt.y:=cy -trunc((cy-dy)*sin(i/transframes*2*pi));
               Frame.canvas.draw(pt.x-dx,pt.y-dy,DrawF.actor.picture.bitmap);
             end;
          end;
        wsActorSpiralLeft:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
             begin
               dx:=DrawF.actor.picture.bitmap.width div 2;
               dy:=DrawF.actor.picture.bitmap.height div 2;
               cx:= w div 2;
               cy:=h div 2;
               rx:=trunc(w /2* (transframes-i)/transframes);
               ry:=trunc(h /2* (transframes-i)/transframes);
               pt.x:=cx +trunc((rx-dx)*cos(i/transframes*2*pi));
               pt.y:=cy -trunc((ry-dy)*sin(i/transframes*2*pi));
               Frame.canvas.draw(pt.x-dx,pt.y-dy,DrawF.actor.picture.bitmap);
             end;
          end;
        wsActorSpiralRight:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
             begin
               dx:=DrawF.actor.picture.bitmap.width div 2;
               dy:=DrawF.actor.picture.bitmap.height div 2;
               cx:= w div 2;
               cy:=h div 2;
               rx:=trunc(w /2* (transframes-i)/transframes);
               ry:=trunc(h /2* (transframes-i)/transframes);
               pt.x:=cx +trunc((rx-dx)*cos(-i/transframes*2*pi));
               pt.y:=cy -trunc((ry-dy)*sin(-i/transframes*2*pi));
               Frame.canvas.draw(pt.x-dx,pt.y-dy,DrawF.actor.picture.bitmap);
             end;
          end;
        wsActorCircleRight:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
             begin
               dx:=DrawF.actor.picture.bitmap.width div 2;
               dy:=DrawF.actor.picture.bitmap.height div 2;
               cx:=w div 2;
               cy:=h div 2;
               pt.x:=cx +trunc((cx-dx)*cos(-i/transframes*2*pi));
               pt.y:=cy -trunc((cy-dy)*sin(-i/transframes*2*pi));
               Frame.canvas.draw(pt.x-dx,pt.y-dy,DrawF.actor.picture.bitmap);
             end;
          end;
        wsActorSwing:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
             begin
               dx:=DrawF.actor.picture.bitmap.width div 2;
               dy:=DrawF.actor.picture.bitmap.height div 2;
               cx:=w div 2;
               cy:=h div 2;
               pt.x:=cx +trunc((cx-dx)*cos(i/transframes*2*pi));
               pt.y:=cy +abs(trunc((cy-dy)*sin(i/transframes*2*pi)));
               Frame.canvas.draw(pt.x-dx,pt.y-dy,DrawF.actor.picture.bitmap);
             end;
          end;
        wsActorQuatro:
          begin
             Frame.canvas.brush.style:=bssolid;
             Frame.canvas.draw(0,0,BMA);
             if assigned(DrawF.actor.picture.bitmap) then
             begin
               dx:=DrawF.actor.picture.bitmap.width div 2;
               dy:=DrawF.actor.picture.bitmap.height div 2;
               cx:=w div 2;
               cy:=h div 2;
               pt.x:=trunc(i/transframes*(cx-dx));
               pt.y:=trunc(i/transframes*(cy-dy));
               Frame.canvas.draw(cx+pt.x-dx,cy+pt.y-dy,DrawF.actor.picture.bitmap);
               Frame.canvas.draw(cx-pt.x-dx,cy+pt.y-dy,DrawF.actor.picture.bitmap);
               Frame.canvas.draw(cx+pt.x-dx,cy-pt.y-dy,DrawF.actor.picture.bitmap);
               Frame.canvas.draw(cx-pt.x-dx,cy-pt.y-dy,DrawF.actor.picture.bitmap);
             end;
          end;
      end;
      wizlist.Add (frame,nil);
      Application.ProcessMessages;
    END;
    case Astyle of
    wsrotateleftright,wsRotateTopDown,wsFadeInOut,
     wsMarqueeUpDown,wsMarqueeLeftRight:
      FOR i := 1 TO TransFrames DO
      BEGIN
       case Astyle of
        wsrotateleftright: TransExpandHor(BMB,i,TransFrames);
        wsRotateTopDown: TransExpandVert(BMB,i,TransFrames);
        wsMarqueeUpDown: TransMarqueeDown(BMA,BMB,i,TransFrames);
        wsMarqueeLeftRight: TransMarqueeRight(BMA,BMB,i,TransFrames);
        wsFadeInOut:
          begin
          frame.canvas.draw(0,0,BMA);
          janFX.Darkness (Frame,round(i/Transframes*255));
          end;
       end;
//      Frame.Assign (bitmap);
      wizlist.Add (Frame,nil);
//      bitmap.free;
      Application.ProcessMessages;
      END;
    end;
  FINALLY
    Screen.Cursor := crDefault;
  END;
BMA.free;
BMB.free;
animatewizList;
if not JanSoft then WizLite(Astyle);
end;

procedure TMoviesF.TextAccent(frm,bm:TBitmap;i,transframes:integer);
var s,s1,s2,s3:string;
    col:Tcolor;
    x:integer;
begin
  frm.canvas.brush.style:=bssolid;
  frm.canvas.draw(0,0,bm);
  frm.canvas.brush.style:=bsclear;
  frm.canvas.font.Assign(wizfont);
  s:=wiztext[0];
  s1:=copy(s,1,i-1);
  s2:=copy(s,i,1);
  s3:=copy(s,i+1,length(s));
  frm.canvas.TextOut(wizpos.x,wizpos.y,s1);
  col:=wizfont.Color;
  frm.canvas.font.color:=wizaccent;
  x:=frm.Canvas.TextWidth(s1);
  frm.canvas.TextOut(wizpos.x+x,wizpos.y,s2);
  x:=frm.Canvas.TextWidth(s1+s2);
  frm.canvas.font.color:=col;
  frm.canvas.TextOut(wizpos.x+x,wizpos.y,s3);  
end;

procedure TMoviesF.WizLite(Astyle:Twizardstyle);
begin
{case AStyle of
    wsSmoothRotate,wsFishEye,wsSplitBlur,wsGaussianBlur,wsTwist,
    wsSqueezeTop,wsSqueezeBottom,wsSqueezeDiamond,wsSqueezeWaste,
    wsSqueezeRound,wsSqueezeRound2,wsMozaic,
    wsColorNoise,wsMonoNoise,wsBrightness,
    wsSplitLight,wsSplitLightReverse,
    wsContrast,wsSaturation,wsTile,
    wsGrowCenter,wsGrowTop,wsGrowBottom,
    wsShrinkCenter,wsShrinkTop,wsShrinkBottom,
    wsSegmentTop,wsSegmentLeft,wsSegmentRight,wsSegmentBottom,
    wsWings,wsFadeIn,wsFadeOut,wsFadeInOut,
    wsSpot,wsSpotLarge,wsSpotFade,wsSpotLargeFade,
    wsCheckerHor,
    wsFoldRight,wsMaskMandelBrot,
    wsFilterBlue,wsFilterGreen,wsFilterRed,
    wsKeepBlue,wsKeepGreen,wsKeepRed,
    wsShake,wsShakeDown,wsPlasmaSmall,wsPlasmaLarge,
    wsPlasmaXLarge,wsPlasmaTurbo,wsTriangles,
    wsTexTile,wsTexoverlap,wsTextType, wsTextMarquee:}
   if ord(AStyle)>=ord(wssmoothrotate) then
   begin
   initwizlist;
   showmessage('This wizard only available in Pro version');
   end;
//  end;
end;

procedure TMoviesF.insertwizlist;
var i:integer;
begin
if wizlist.count=0 then exit;
selectnone;
for i:=0 to wizlist.count-1 do begin
  list.Items.BeginUpdate ;
  wizlist.GetBitmap (i,frame);
  insertimage;
  list.items.EndUpdate ;
  end;
arrange;
end;


procedure TMoviesF.SetFrames1Click(Sender: TObject);
var i:integer;
    s:string;
begin
s:=inttostr(transframes);
s:=inputbox('Movies Transitions','Enter number of frames (4..50):',s);
i:=strtointdef(s,10);
if i>50 then i:=50;
if i<4 then i:=4;
transframes:=i;
end;

procedure TMoviesF.FrameDelay1Click(Sender: TObject);
var i:integer;
    s:string;
begin
s:=inttostr(FrameDelay);
s:=inputbox('Movies Transitions','Enter Default Frame Delay (10..255):',s);
i:=strtointdef(s,10);
if i>255 then i:=255;
if i<10 then i:=10;
FrameDelay:=i;
end;

procedure TMoviesF.DefTransClick(Sender: TObject);
begin
deftrans.Checked := not deftrans.Checked ;
end;

procedure TMoviesF.Open2Click(Sender: TObject);
var GIF:Tgifimage;
    i:integer;
begin
if opendialog1.execute then begin
  thefile:=opendialog1.filename;
  opendialog1.InitialDir :=extractfilepath(thefile);
  clear;
  GIF:=tgifimage.Create ;
  GIF.LoadFromFile (thefile);
  if GIF.images.count>0 then
    for i:=0 to GIF.Images.Count -1 do
      AddFrame(GIF,i);
  GIF.Free ;
  end;
end;

procedure TMoviesF.GIFExplorer1Click(Sender: TObject);
begin
GIFExplorerF.show;

end;

procedure TMoviesF.Effect1Click(Sender: TObject);
var im:timage;
begin
if framepop.popupcomponent=list then begin
  if list.itemindex<>-1 then
  im:=GetImage(list.itemindex)
  else exit;
  end
  else
  im:=TImage(framepop.popupcomponent);
with painterEffectsF do begin
  Eclip.assign(im.picture.bitmap);
  cxbar.Max :=Eclip.width;
  cybar.max :=Eclip.height;
  cxbar.Position :=Eclip.width div 2;
  cybar.position :=Eclip.height div 2;
  end;
 if PainterEffectsF.ShowModal=mrOk then
   im.picture.bitmap.Assign(
        PainterEffectsF.image.picture.bitmap);
list.Invalidate ;
end;

procedure TMoviesF.Backgrounds1Click(Sender: TObject);
var im:timage;
begin
if framepop.popupcomponent=list then begin
  if list.itemindex<>-1 then
  im:=GetImage(list.itemindex)
  else exit;
  end
  else
  im:=TImage(framepop.popupcomponent);
  with painterQBF do begin
  Qclip.assign(im.picture.bitmap);
  if ((Qclip.width=0) or (Qclip.height=0)) then begin
    showmessage(' empty bitmap');
    exit;
    end;
  end;
 if PainterQBF.ShowModal=mrOk then
   im.picture.bitmap.Assign(
        PainterQBF.image.picture.bitmap);
 list.Invalidate ;
end;

procedure TMoviesF.DelayAll1Click(Sender: TObject);
var index,d:integer;
    s:string;
begin
if list.items.count=0 then exit;
s:=inttostr(framedelay);
s:=inputbox('Movies Frame Delays','Enter Delay (10..255)',s);
d:=strtointdef(s,30);
if ((d>=10) and (d<=255)) then begin
  for index:=0 to list.items.count-1 do
    list.items.values[list.items.names[index]]:=s;
  end;
end;

procedure TMoviesF.GradText1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var g:TGradtext;
begin
if button=mbleft then begin
  g:=TGradText(sender);
  g.bringtofront;
  if (g.width-x)<10 then begin
    g.tag:=2;
    GadLabelX:=(g.width)-x;
    end
    else begin
    g.tag:=1;
    GadLabelX:=x;
    GadLabelY:=y;
    end;
  end;

end;
procedure TMoviesF.GradText1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var Apoint:Tpoint;
    g:TGradText;
begin
g:=TGradText(sender);
  if g.width-x<10 then
    g.Cursor :=crSizeWE
    else g.cursor:=crdefault;
if g.tag=1 then begin
  Apoint:=g.ClientToScreen (point(x,y));
  Apoint.x:=Apoint.x-GadLabelX;
  Apoint.y:=Apoint.y-GadLabelY;
  apoint:=scrollboxsource.ScreenToClient (Apoint);
  g.left:=Apoint.x;
  g.top:=Apoint.y;
  end
  else if g.tag=2 then begin
  g.width:=x+GadLabelX;
  end;
end;

procedure TMoviesF.GradText1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TGradText(sender).tag:=0;
end;

procedure TMoviesF.AVItoGIFconverter1Click(Sender: TObject);
begin
avi2gifF.show;
avi2gifF.BringToFront ;
end;

procedure TMoviesF.GIFtoAVIconverter1Click(Sender: TObject);
begin
gif2aviF.show;
gif2aviF.BringToFront ;
end;

procedure TMoviesF.Optimize1Click(Sender: TObject);
var bm:tbitmap;
begin
if framepop.popupcomponent=list then begin
  if list.itemindex<>-1 then
  bm:=GetImage(list.itemindex).picture.bitmap
  else exit;
  end
  else
  bm:=Timage(framepop.popupcomponent).picture.bitmap;
with PainterReduceF do begin
  imagebitmap.Width :=bm.width;
  imagebitmap.height:=bm.height;
  imagegif.width:=bm.width;
  imagegif.height:=bm.height;
  imagebitmap.canvas.draw(0,0,bm);
  showmodal;
  end;
end;

procedure TMoviesF.FormDestroy(Sender: TObject);
begin
  Frame.free;
  wizfont.free;
  wiztext.free;
  SaveSettings;
end;

procedure TMoviesF.loadsettings;
var f:tinifile;
    ini:string;
    mode:boolean;
begin
ini:=changefileext(paramstr(0),'.ini');
f:=tinifile.create(ini);
mode:=f.ReadBool ('Window','State',false);
if mode then
 windowstate:=wsmaximized
 else begin
 left:=f.ReadInteger ('Window','Left',left);
 top:=f.ReadInteger ('Window','Top',top);
 width:=f.ReadInteger('Window','Width',width);
 height:=f.ReadInteger('Window','Height',height);
 end;
dirbox.Directory :=f.ReadString('Directories','Frames',appldir);
opendialog1.InitialDir:=f.ReadString('Directories','Open',appldir);
savedialog1.InitialDir:=f.ReadString('Directories','Save',appldir);
transframes:=f.ReadInteger ('Frames','Count',10);
if transframes<4 then transframes:=4;
if transframes>50 then transframes:=50;
DefaultWidth:=f.readInteger('Frames','Width',120);
Defaultheight:=f.readInteger('Frames','Height',60);
FrameDelay:=f.readInteger('Frames','Delay',10);
if FrameDelay>255 then FrameDelay:=255;
if FrameDelay<10 then FrameDelay:=10;
f.free;
end;

procedure TMoviesF.savesettings;
var f:tinifile;
    ini:string;
    mode:boolean;
begin
ini:=changefileext(paramstr(0),'.ini');
f:=tinifile.create(ini);
mode:= windowstate=wsmaximized;
f.WriteBool ('Window','State',mode);
if not mode then begin
 f.WriteInteger ('Window','Left',left);
 f.WriteInteger ('Window','Top',top);
 f.WriteInteger('Window','Width',width);
 f.WriteInteger('Window','Height',height);
 end;
f.WriteString('Directories','Frames',dirbox.Directory);
f.WriteString('Directories','Open',opendialog1.InitialDir);
f.WriteString('Directories','Save',savedialog1.InitialDir);
f.WriteInteger ('Frames','Count',transframes);
f.WriteInteger('Frames','Width',DefaultWidth);
f.WriteInteger('Frames','Height',Defaultheight);
f.WriteInteger('Frames','Delay',FrameDelay);
f.free;
end;


procedure TMoviesF.New2Click(Sender: TObject);
begin
if messagedlg('Do you want to erase all current Frames?',
  mtconfirmation,[mbyes,mbno],0)=mryes then DeleteAll;
end;

procedure TMoviesF.Edit1Click(Sender: TObject);
begin
if list.itemindex<>-1 then
  IFrameDblClick(GetImage(list.itemindex));
end;

procedure TMoviesF.Delete2Click(Sender: TObject);
begin
Delete1click(sender);
end;

procedure TMoviesF.framepopPopup(Sender: TObject);
begin
  transparent1.checked:=TImage(framepop.popupcomponent).transparent;
  popcurpos:=mouse.CursorPos;
end;

procedure TMoviesF.Transparent1Click(Sender: TObject);
var im:timage;
begin
if framepop.popupcomponent=list then begin
  if list.itemindex<>-1 then
  im:=GetImage(list.itemindex)
  else exit;
  end
  else
  im:=TImage(framepop.popupcomponent);
 Transparent1.Checked :=not Transparent1.Checked;
 im.transparent:= Transparent1.Checked;
end;

procedure TMoviesF.Create1Click(Sender: TObject);
begin
if list.Items.count>0 then
  Createanimation(true);
end;



procedure TMoviesF.CreateSelection1Click(Sender: TObject);
begin
if list.SelCount>0 then
  Createanimation(false);
end;

procedure TMoviesF.Arrange1Click(Sender: TObject);
begin
Arrange;
end;

procedure TMoviesF.btnnewClick(Sender: TObject);
begin
new2.Click ;
end;

procedure TMoviesF.btnanimateClick(Sender: TObject);
begin
Create1.click;
end;

procedure TMoviesF.btnanimateselectionClick(Sender: TObject);
begin
CreateSelection1.Click ;
end;

procedure TMoviesF.btneditClick(Sender: TObject);
begin
Edit1.Click ;
end;

procedure TMoviesF.btnnewframeClick(Sender: TObject);
begin
gonewclick(sender);
end;

procedure TMoviesF.btndeleteframeClick(Sender: TObject);
begin
Delete1click(sender);
end;

procedure TMoviesF.btnopenClick(Sender: TObject);
begin
open2.Click ;
end;

procedure TMoviesF.btnsaveaniClick(Sender: TObject);
begin
buttonsaveclick(sender);
end;

procedure TMoviesF.btnstopClick(Sender: TObject);
begin
stop1.Click ;
end;

procedure TMoviesF.btnduplicateClick(Sender: TObject);
begin
Duplicate;
end;

procedure TMoviesF.btndelayClick(Sender: TObject);
begin
delay1.Click ;
end;

procedure TMoviesF.btnwizinsertClick(Sender: TObject);
begin
insertwizlist;
end;

procedure TMoviesF.Transition1Click(Sender: TObject);
begin
dowizard(wstransition);
end;

procedure TMoviesF.RotateLeftRight1Click(Sender: TObject);
begin
dowizard(wsrotateleftright);
end;

procedure TMoviesF.RotateTopDown1Click(Sender: TObject);
begin
dowizard(wsrotatetopdown);
end;

procedure TMoviesF.BlindsDown1Click(Sender: TObject);
begin
dowizard(wsblindsdown);
end;

procedure TMoviesF.BlindsRight2Click(Sender: TObject);
begin
dowizard(wsblindsright);
end;

procedure TMoviesF.Right4Click(Sender: TObject);
begin
dowizard(wsWipeRight);
end;

procedure TMoviesF.Left3Click(Sender: TObject);
begin
dowizard(wsWipeLeft);
end;

procedure TMoviesF.Up3Click(Sender: TObject);
begin
dowizard(wsWipeUp);
end;

procedure TMoviesF.Down4Click(Sender: TObject);
begin
dowizard(wsWipeDown);
end;

procedure TMoviesF.OpenHoriz1Click(Sender: TObject);
begin
dowizard(wscurtainoh);
end;

procedure TMoviesF.CloseHoriz1Click(Sender: TObject);
begin
dowizard(wsCurtainCH);
end;

procedure TMoviesF.OpenVert1Click(Sender: TObject);
begin
dowizard(wscurtainOV);
end;

procedure TMoviesF.CloseVert1Click(Sender: TObject);
begin
dowizard(wscurtainCV);
end;

procedure TMoviesF.In2Click(Sender: TObject);
begin
dowizard(wsboxin);
end;

procedure TMoviesF.Out2Click(Sender: TObject);
begin
dowizard(wsboxout);
end;

procedure TMoviesF.DownRight3Click(Sender: TObject);
begin
dowizard(wsdiagonalDR);
end;

procedure TMoviesF.DownLeft3Click(Sender: TObject);
begin
dowizard(wsdiagonalDL);
end;

procedure TMoviesF.UpRight2Click(Sender: TObject);
begin
dowizard(wsdiagonalUR);
end;

procedure TMoviesF.UpLeft3Click(Sender: TObject);
begin
dowizard(wsdiagonalUL);
end;

procedure TMoviesF.In3Click(Sender: TObject);
begin
dowizard(wsCrossIn);
end;

procedure TMoviesF.Out3Click(Sender: TObject);
begin
dowizard(wsCrossOut);
end;

procedure TMoviesF.CircleOut2Click(Sender: TObject);
begin
dowizard(wsCircleOut);
end;

procedure TMoviesF.Left4Click(Sender: TObject);
begin
dowizard(wsSweepLeft);
end;

procedure TMoviesF.Right5Click(Sender: TObject);
begin
dowizard(wsSweepRight);
end;

procedure TMoviesF.LeftRight1Click(Sender: TObject);
begin
dowizard(wsSweepLR);
end;

procedure TMoviesF.SmoothRotate1Click(Sender: TObject);
begin
dowizard(wsSmoothRotate);
end;

procedure TMoviesF.FishEye1Click(Sender: TObject);
begin
dowizard(wsFishEye);
end;

procedure TMoviesF.SplitBlur1Click(Sender: TObject);
begin
dowizard(wsSplitBlur);
end;

procedure TMoviesF.Twist1Click(Sender: TObject);
begin
dowizard(wsTwist);
end;

procedure TMoviesF.Top1Click(Sender: TObject);
begin
dowizard(wsSqueezeTop);
end;

procedure TMoviesF.Bottom1Click(Sender: TObject);
begin
dowizard(wsSqueezeBottom);
end;

procedure TMoviesF.Diamond1Click(Sender: TObject);
begin
dowizard(wsSqueezeDiamond);
end;

procedure TMoviesF.Waste1Click(Sender: TObject);
begin
dowizard(wsSqueezeWaste);
end;

procedure TMoviesF.Color1Click(Sender: TObject);
begin
dowizard(wsColorNoise);
end;

procedure TMoviesF.Mono1Click(Sender: TObject);
begin
dowizard(wsmononoise);
end;

procedure TMoviesF.Gaussian1Click(Sender: TObject);
begin
dowizard(wsGaussianBlur);
end;

procedure TMoviesF.Brightness1Click(Sender: TObject);
begin
dowizard(wsBrightness);
end;

procedure TMoviesF.Round1Click(Sender: TObject);
begin
dowizard(wsSqueezeRound);
end;

procedure TMoviesF.RoundDouble1Click(Sender: TObject);
begin
dowizard(wsSqueezeRound2);
end;

procedure TMoviesF.Mozaic1Click(Sender: TObject);
begin
dowizard(wsMozaic);
end;

procedure TMoviesF.Tile1Click(Sender: TObject);
begin
dowizard(wsTile);
end;

procedure TMoviesF.Grow1Click(Sender: TObject);
begin
dowizard(wsGrowCenter);
end;

procedure TMoviesF.Shrink1Click(Sender: TObject);
begin
dowizard(wsShrinkCenter);
end;

procedure TMoviesF.Top2Click(Sender: TObject);
begin
dowizard(wsGrowTop);
end;

procedure TMoviesF.Top3Click(Sender: TObject);
begin
dowizard(wsShrinkTop);
end;

procedure TMoviesF.ToolBar1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
if x<(btnwizard.left+12) then
  btnwizard.ImageIndex :=11
  else
  btnwizard.ImageIndex :=13;

end;

procedure TMoviesF.ScrollBoxSourceMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
if x<(btnwizard.left+12) then
  btnwizard.ImageIndex :=11
  else
  btnwizard.ImageIndex :=13;
end;

procedure TMoviesF.Bottom2Click(Sender: TObject);
begin
dowizard(wsGrowBottom);
end;

procedure TMoviesF.Bottom3Click(Sender: TObject);
begin
dowizard(wsShrinkBottom);
end;

procedure TMoviesF.Top4Click(Sender: TObject);
begin
dowizard(wsSegmentTop);
end;

procedure TMoviesF.Left2Click(Sender: TObject);
begin
dowizard(wsSegmentLeft);
end;

procedure TMoviesF.Right3Click(Sender: TObject);
begin
dowizard(wsSegmentRight);
end;

procedure TMoviesF.Bottom4Click(Sender: TObject);
begin
dowizard(wsSegmentBottom);
end;

procedure TMoviesF.Wings1Click(Sender: TObject);
begin
dowizard(wsWings);
end;

procedure TMoviesF.Contrast1Click(Sender: TObject);
begin
dowizard(wsContrast);
end;

procedure TMoviesF.Saturation1Click(Sender: TObject);
begin
dowizard(wsSaturation);
end;

procedure TMoviesF.Darkness1Click(Sender: TObject);
begin
dowizard(wsFadeIn);
end;

procedure TMoviesF.FadeOut1Click(Sender: TObject);
begin
dowizard(wsFadeOut);
end;

procedure TMoviesF.FadeInOut1Click(Sender: TObject);
begin
dowizard(wsFadeInOut);
end;

procedure TMoviesF.SpotLeftRight1Click(Sender: TObject);
begin
dowizard(wsSpot);
end;

procedure TMoviesF.SpotLarge1Click(Sender: TObject);
begin
dowizard(wsSpotLarge);
end;

procedure TMoviesF.SpotFade1Click(Sender: TObject);
begin
dowizard(wsSpotFade);
end;

procedure TMoviesF.SpotLargeFade1Click(Sender: TObject);
begin
dowizard(wsSpotLargeFade);
end;

procedure TMoviesF.SplitLight1Click(Sender: TObject);
begin
dowizard(wsSplitLight);
end;

procedure TMoviesF.SplitLightReverse1Click(Sender: TObject);
begin
dowizard(wsSplitLightReverse);
end;

procedure TMoviesF.FlipLeftRight1Click(Sender: TObject);
begin
if list.itemindex<>-1 then
  janFX.FlipRight (GetImage(list.itemindex).picture.bitmap);
list.invalidate;
end;

procedure TMoviesF.FlipUpDown1Click(Sender: TObject);
begin
if list.itemindex<>-1 then
  janFX.FlipDown (GetImage(list.itemindex).picture.bitmap);
list.invalidate;
end;

procedure TMoviesF.Rotate1Click(Sender: TObject);
begin
rotate(sender);
list.invalidate;
end;

procedure TMoviesF.UpLeft2Click(Sender: TObject);
var
  x,y : integer;
  bm,BitMap : TBitMap;
  P1,P2 : PByteArray;
begin
if list.itemindex=-1 then exit;
  bm:=GetImage(list.itemindex).picture.bitmap;
  BitMap := TBitMap.create;
  Bitmap.width:=bm.Width ;
  Bitmap.height:=bm.height;
  Bitmap.canvas.draw(0,0,bm);
  janFX.shadowupleft (bitmap);
  bm.Assign (Bitmap);
  BitMap.free;
list.invalidate;
end;

procedure TMoviesF.UpRight1Click(Sender: TObject);
var
  x,y : integer;
  bm,BitMap : TBitMap;
  P1,P2 : PByteArray;
begin
if list.itemindex=-1 then exit;
  bm:=GetImage(list.itemindex).picture.bitmap;
  BitMap := TBitMap.create;
  Bitmap.width:=bm.Width ;
  Bitmap.height:=bm.height;
  Bitmap.canvas.draw(0,0,bm);
  janFX.shadowupright (bitmap);
  bm.Assign (Bitmap);
  BitMap.free;
list.invalidate;
end;

procedure TMoviesF.DownLeft2Click(Sender: TObject);
var
  x,y : integer;
  bm,BitMap : TBitMap;
  P1,P2 : PByteArray;
begin
if list.itemindex=-1 then exit;
  bm:=GetImage(list.itemindex).picture.bitmap;
  BitMap := TBitMap.create;
  Bitmap.width:=bm.Width ;
  Bitmap.height:=bm.height;
  Bitmap.canvas.draw(0,0,bm);
  janFX.ShadowDownLeft(bitmap);
  bm.Assign (Bitmap);
  BitMap.free;
list.invalidate;
end;

procedure TMoviesF.DownRight2Click(Sender: TObject);
var
  x,y : integer;
  bm,BitMap : TBitMap;
  P1,P2 : PByteArray;
begin
if list.itemindex=-1 then exit;
  bm:=GetImage(list.itemindex).picture.bitmap;
  BitMap := TBitMap.create;
  Bitmap.width:=bm.Width ;
  Bitmap.height:=bm.height;
  Bitmap.canvas.draw(0,0,bm);
  janFX.ShadowDownRight (bitmap);
  bm.Assign (Bitmap);
  BitMap.free;
list.invalidate;
end;

procedure TMoviesF.Right2Click(Sender: TObject);
begin
dowizard(wsCheckerHor);
end;

procedure TMoviesF.Up2Click(Sender: TObject);
begin
dowizard(wsMarqueeUp);
end;

procedure TMoviesF.Down2Click(Sender: TObject);
begin
dowizard(wsMarqueeDown);
end;

procedure TMoviesF.UpDown1Click(Sender: TObject);
begin
dowizard(wsMarqueeUpDown);
end;

procedure TMoviesF.Left5Click(Sender: TObject);
begin
dowizard(wsMarqueeLeft);
end;

procedure TMoviesF.Right6Click(Sender: TObject);
begin
dowizard(wsMarqueeRight);
end;

procedure TMoviesF.LeftRight2Click(Sender: TObject);
begin
dowizard(wsMarqueeLeftRight);
end;

procedure TMoviesF.N50Opaque1Click(Sender: TObject);
  VAR
    BMA,BMB:  TBitmap;
    index,w,h  :  INTEGER;
begin
index:=list.itemindex;
if ((index<0) or (index>(list.items.count-2))) then exit;
w:=FrameWidth;
h:=Frameheight;
BMA:=Tbitmap.create;
BMA.width:=w;
BMA.height:=h;
BMA.assign(GetImage(index).picture.bitmap);
BMA.PixelFormat :=pf24bit;
BMB:=Tbitmap.create;
BMB.width:=w;
BMB.height:=h;
BMB.assign(GetImage(index+1).picture.bitmap);
BMB.PixelFormat :=pf24bit;
janFX.semiOpaque (BMB,BMA);
GetImage(index).picture.bitmap.assign(BMA);
BMA.free;
BMB.free;
list.invalidate;
end;

procedure TMoviesF.N25Opaque1Click(Sender: TObject);
  VAR
    BMA,BMB:  TBitmap;
    index,w,h  :  INTEGER;
begin
index:=list.itemindex;
if ((index<0) or (index>(list.items.count-2))) then exit;
w:=FrameWidth;
h:=Frameheight;
BMA:=Tbitmap.create;
BMA.width:=w;
BMA.height:=h;
BMA.assign(GetImage(index).picture.bitmap);
BMA.PixelFormat :=pf24bit;
BMB:=Tbitmap.create;
BMB.width:=w;
BMB.height:=h;
BMB.assign(GetImage(index+1).picture.bitmap);
BMB.PixelFormat :=pf24bit;
janFX.QuartoOpaque(BMB,BMA);
GetImage(index).picture.bitmap.assign(BMA);
BMA.free;
BMB.free;
list.invalidate;
end;

procedure TMoviesF.ListDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
   h,w:integer;
   R,rt:trect;
   bm:Tbitmap;
   factor:extended;
begin
if index<0 then exit;
bm:=GetImage(index).picture.bitmap;
r:=rect;
rt:=rect;
h:=r.bottom-r.top;
w:=r.right-r.left;
r.top:=r.top+2;
r.bottom:=r.bottom-2;
r.left:=r.left+2;
factor:=2;
if bm.height>32 then
  factor:=bm.width/bm.height;
if factor<2 then
 r.right:=r.left+round(factor*h)-4
 else
 r.right:=r.left+2*h-4;
list.canvas.StretchDraw (r,bm);
list.canvas.TextOut (rect.left+2*h+4,rect.top,list.items[index]);
end;

procedure TMoviesF.ListDblClick(Sender: TObject);
begin
if list.itemindex<>-1 then
  IFrameDblClick(GetImage(list.itemindex));
end;

procedure TMoviesF.Right7Click(Sender: TObject);
begin
dowizard(wsFoldRight);
end;

procedure TMoviesF.MaskMandelBrot1Click(Sender: TObject);
begin
dowizard(wsMaskMandelBrot);
end;

procedure TMoviesF.FilterBlue1Click(Sender: TObject);
begin
dowizard(wsFilterBlue);
end;

procedure TMoviesF.FilterGreen1Click(Sender: TObject);
begin
dowizard(wsFilterGreen);
end;

procedure TMoviesF.FilterRed1Click(Sender: TObject);
begin
dowizard(wsFilterRed);
end;

procedure TMoviesF.KeepBlue1Click(Sender: TObject);
begin
dowizard(wsKeepBlue);
end;

procedure TMoviesF.KeepGreen1Click(Sender: TObject);
begin
dowizard(wsKeepGreen);
end;

procedure TMoviesF.KeepRed1Click(Sender: TObject);
begin
dowizard(wsKeepRed);
end;

procedure TMoviesF.MultiShake1Click(Sender: TObject);
begin
dowizard(wsShake);
end;

procedure TMoviesF.UpDown2Click(Sender: TObject);
begin
dowizard(wsShakeDown);
end;


procedure TMoviesF.setProLite;
begin
  if JanSoft then
  begin
  register1.visible:=false;
  purchaseonline1.Visible :=false;
  caption:='Jans Movies 11b - Pro';
  btnanimateselection.Enabled :=true;
  end
  else begin
  register1.visible:=true;
  purchaseonline1.Visible :=true;
  caption:='Jans Movies 11b - Lite';
  btnanimateselection.Enabled :=false;
  end;

end;





procedure TMoviesF.WebSite1Click(Sender: TObject);
var command,params,workdir:string;
begin
command:='http://jansfreeware.com';
params:=#0;
workdir:=#0;
shellexecute(handle,'open',@command[1],
  @params[1],@workdir[1], SW_SHOWNORMAL);
end;

procedure TMoviesF.ProPlasma1Click(Sender: TObject);
begin
dowizard(wsPlasmaSmall);
end;

procedure TMoviesF.Large1Click(Sender: TObject);
begin
dowizard(wsPlasmaLarge);
end;

procedure TMoviesF.ExtraLarge1Click(Sender: TObject);
begin
dowizard(wsPlasmaXLarge);
end;

procedure TMoviesF.LargeTurbo1Click(Sender: TObject);
begin
dowizard(wsPlasmaTurbo);
end;

procedure TMoviesF.Blur2Click(Sender: TObject);
var w,h,i,j,linebytes,index:integer;
  bm:tbitmap;
begin
index:=list.itemindex;
if index<0 then exit;
bm:=GetImage(index).picture.bitmap;
frame.width:=bm.width;
frame.height:=bm.height;
frame.PixelFormat :=pf24bit;
frame.canvas.draw(0,0,bm);
janFX.SplitBlur(frame,2);
bm.Assign (frame);
list.Invalidate;
end;

procedure TMoviesF.FlipLeftRight2Click(Sender: TObject);
var w,h,i,j,linebytes,index:integer;
  bm:tbitmap;
begin
index:=list.itemindex;
if index<0 then exit;
bm:=GetImage(index).picture.bitmap;
frame.width:=bm.width;
frame.height:=bm.height;
frame.PixelFormat :=pf24bit;
frame.canvas.draw(0,0,bm);
janFX.FlipRight(frame);
bm.Assign (frame);
list.Invalidate;
end;

procedure TMoviesF.FlipTopDown1Click(Sender: TObject);
var w,h,i,j,linebytes,index:integer;
  bm:tbitmap;
begin
index:=list.itemindex;
if index<0 then exit;
bm:=GetImage(index).picture.bitmap;
frame.width:=bm.width;
frame.height:=bm.height;
frame.PixelFormat :=pf24bit;
frame.canvas.draw(0,0,bm);
janFX.FlipDown(frame);
bm.Assign (frame);
list.Invalidate;
end;
procedure TMoviesF.Right8Click(Sender: TObject);
var w,h,i,j,linebytes,index:integer;
  bm:tbitmap;
begin
index:=list.itemindex;
if index<0 then exit;
bm:=GetImage(index).picture.bitmap;
frame.width:=bm.width;
frame.height:=bm.height;
frame.PixelFormat :=pf24bit;
frame.canvas.draw(0,0,bm);
janFX.MirrorRight(frame);
bm.canvas.draw(0,0,frame);
list.Invalidate;
end;

procedure TMoviesF.Down3Click(Sender: TObject);
var w,h,i,j,linebytes,index:integer;
  bm:tbitmap;
begin
index:=list.itemindex;
if index<0 then exit;
bm:=GetImage(index).picture.bitmap;
frame.width:=bm.width;
frame.height:=bm.height;
frame.PixelFormat :=pf24bit;
frame.canvas.draw(0,0,bm);
janFX.MirrorDown(frame);
bm.canvas.draw(0,0,frame);
list.Invalidate;
end;

procedure TMoviesF.Triangles1Click(Sender: TObject);
begin
dowizard(wsTriangles);
end;

procedure TMoviesF.Tile2Click(Sender: TObject);
begin
dowizard(wsTexTile);
end;

procedure TMoviesF.TileOverlap1Click(Sender: TObject);
begin
dowizard(wsTexoverlap);
end;

procedure TMoviesF.TextWizardFont1Click(Sender: TObject);
begin
  fontdialog1.Font.Assign(wizfont);
  if fontdialog1.Execute then
  begin
    wizfont.name:=fontdialog1.font.Name;
    wizfont.size:=fontdialog1.font.size;
    wizfont.Color:=fontdialog1.Font.Color;
    wizfont.style:=fontdialog1.font.style;    
  end;
end;

procedure TMoviesF.Type1Click(Sender: TObject);
begin
  dowizard(wstexttype);
end;

procedure TMoviesF.TextWizardText1Click(Sender: TObject);
var s:string;
begin
  TemplatesF.editor.Text:=wiztext.text;
  if TemplatesF.ShowModal=mrok then
    wiztext.text:=templatesF.editor.text;
end;

procedure TMoviesF.TextWizardColor1Click(Sender: TObject);
begin
  colordialog1.color:=wizfont.Color;
  if colordialog1.execute then
    wizfont.color:=colordialog1.Color;
end;

procedure TMoviesF.Grow3Click(Sender: TObject);
begin
  dowizard(wstextgrow);
end;

procedure TMoviesF.MarkTextPosition1Click(Sender: TObject);
var im:TImage;
begin
  if framepop.popupcomponent<>list then
  begin
     im:=TImage(framepop.popupcomponent);
     wizpos:=im.ScreenToClient(popcurpos);
  end;
end;

procedure TMoviesF.Marquee2Click(Sender: TObject);
begin
  dowizard(wsTextmarquee);
end;

procedure TMoviesF.Lines1Click(Sender: TObject);
begin
  dowizard(wsTextLines);
end;

procedure TMoviesF.Accent1Click(Sender: TObject);
begin
  dowizard(wsTextAccent);
end;

procedure TMoviesF.AccentColor1Click(Sender: TObject);
begin
  colordialog1.color:=wizaccent;
  if colordialog1.execute then
    wizAccent:=colordialog1.Color;

end;

procedure TMoviesF.Buttonize1Click(Sender: TObject);
begin
  dowizard(wsbuttonize);
end;

procedure TMoviesF.DancingSpot1Click(Sender: TObject);
begin
  dowizard(wsdancespot);
end;

procedure TMoviesF.Right9Click(Sender: TObject);
begin
  dowizard(wsactorright);
end;

procedure TMoviesF.Left6Click(Sender: TObject);
begin
  dowizard(wsactorleft);
end;

procedure TMoviesF.Down5Click(Sender: TObject);
begin
  dowizard(wsactordown);
end;

procedure TMoviesF.Up4Click(Sender: TObject);
begin
  dowizard(wsactorup);
end;

procedure TMoviesF.Path1Click(Sender: TObject);
begin
  dowizard(wsactorpath);
end;

procedure TMoviesF.Circle1Click(Sender: TObject);
begin
  dowizard(wsactorcircleleft);
end;

procedure TMoviesF.CircleRight1Click(Sender: TObject);
begin
  dowizard(wsactorcircleright);
end;

procedure TMoviesF.Swing1Click(Sender: TObject);
begin
  dowizard(wsactorswing);
end;

procedure TMoviesF.Quatro1Click(Sender: TObject);
begin
  dowizard(wsactorquatro);
end;

procedure TMoviesF.Spiral1Click(Sender: TObject);
begin
  dowizard(wsactorspiralleft);
end;

procedure TMoviesF.SpiralRight1Click(Sender: TObject);
begin
  dowizard(wsactorspiralRight);
end;

procedure TMoviesF.SetLoops1Click(Sender: TObject);
var n:integer;
    s:string;
begin
  s:=inttostr(loops);
  if inputquery('GIF animation settings','Enter number of loops (0 = forever):',s) then begin
    loops:=strtointdef(s,0);
  end
end;

end.

var
  // Image cache - Must have been loaded with 10 TBitmaps of equal height
  Images: array[0..9] of TBitmap;

function IntToGIF(Value: integer; Width: integer): TGIFImage;
var
  s: string;
  i: integer;
  Width: integer;
  Bitmap: TBitmap;
begin
  s := format('%.*d', [Width, Value]);
  // Convert ASCII to decimal
  for i := 1 to length(s) do
    s[i] := chr(ord(s[i])-ord('0'));


  // Calculate width of GIF
  Width := 0;
  for i := 1 to length(s) do
    inc(Width, Images[ord(s[i])].Width);

  // Create work bitmap
  Bitmap := TBitmap.Create;
  try
    // Set size of bitmap
    Bitmap.Height := Images[0].height;
    Bitmap.Width := Width;

    // Draw your gradient here...

    // Draw each digit on the bitmap
    Width := 0;
    for i := 1 to length(s) do
    begin
      Bitmap.Canvas.Draw(Width, 0, Images[ord(s[i])]);
      inc(Width, Images[ord(s[i])].Width);
    end;

    Result := TGIFimage.Create;
    try
      // Convert bitmap to GIF
      GIF.Assign(Bitmap);
    except
      Result.Free;
      raise;
    end;
  finally
    Bitmap.Free;
  end;
end;

